(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 10.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    159417,       3916]
NotebookOptionsPosition[    158571,       3882]
NotebookOutlinePosition[    158928,       3898]
CellTagsIndexPosition[    158885,       3895]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["ME 449 HW3 - Code", "Title",
 CellChangeTimes->{{3.6553035449680643`*^9, 3.655303549730874*^9}, {
  3.656101536777555*^9, 3.6561015467491903`*^9}}],

Cell[CellGroupData[{

Cell["Matt Collins", "Chapter",
 CellChangeTimes->{{3.655303553994246*^9, 3.655303560018202*^9}}],

Cell[CellGroupData[{

Cell["1)", "Section",
 CellChangeTimes->{{3.655303610279749*^9, 3.655303610736115*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"FixedJacobian", "[", 
      RowBox[{"Si_", ",", "\[Theta]i_"}], "]"}], ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "Takes", " ", "a", " ", "set", " ", "of", " ", "joint", " ", "angles", 
       " ", "\[Theta]i"}], " ", "\[Element]", " ", 
      RowBox[{
       SuperscriptBox["R", "n"], " ", "and", " ", "a", " ", "set", " ", "of", 
       " ", "screw", " ", "axes", " ", "Si", " ", "for", " ", "the", " ", 
       "robot", " ", "joints", " ", "expressed", " ", "in", " ", "the", " ", 
       "fixed", " ", 
       RowBox[{"frame", ".", " ", "The"}], " ", "function", " ", "returns", 
       " ", "the", " ", "space", " ", "Jacobian", " ", 
       SubscriptBox["J", "S"], 
       RowBox[{"(", "\[Theta]", ")"}]}], " ", "\[Element]", " ", 
      RowBox[{
       SuperscriptBox["R", 
        RowBox[{"6", "xn"}]], ".", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "Sample"}]}], ":", "\[IndentingNewLine]", "\t", 
     "Input", ":"}], "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
    RowBox[{"S1", " ", "=", " ", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
        "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"S2", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
         RowBox[{"-", "L1"}], ",", "0"}], "}"}], "}"}], "\[Transpose]"}]}], 
    ";", "\[IndentingNewLine]", 
    RowBox[{"S3", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
         RowBox[{
          RowBox[{"-", "L1"}], "-", "L2"}], ",", "0"}], "}"}], "}"}], 
      "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"S4", "=", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
        "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
    RowBox[{"S", "=", 
     RowBox[{"{", 
      RowBox[{"S1", ",", "S2", ",", "S3", ",", "S4"}], "}"}]}], ";", 
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Simplify", "[", 
      RowBox[{"FixedJacobian", "[", 
       RowBox[{"S", ",", 
        RowBox[{"{", 
         RowBox[{
         "\[Theta]1", ",", "\[Theta]2", ",", "\[Theta]3", ",", "\[Theta]4"}], 
         "}"}]}], "]"}], "]"}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", "\[IndentingNewLine]", "\t", 
      RowBox[{"Ouput", ":", "\[IndentingNewLine]", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0", "0", "0"},
           {"0", "0", "0", "0"},
           {"1", "1", "1", "0"},
           {"0", 
            RowBox[{"L1", " ", 
             RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], 
            RowBox[{
             RowBox[{"L1", " ", 
              RowBox[{"Sin", "[", "\[Theta]1", "]"}]}], "+", 
             RowBox[{"L2", " ", 
              RowBox[{"Sin", "[", 
               RowBox[{"\[Theta]1", "+", "\[Theta]2"}], "]"}]}]}], "0"},
           {"0", 
            RowBox[{
             RowBox[{"-", "L1"}], " ", 
             RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], 
            RowBox[{
             RowBox[{
              RowBox[{"-", "L1"}], " ", 
              RowBox[{"Cos", "[", "\[Theta]1", "]"}]}], "-", 
             RowBox[{"L2", " ", 
              RowBox[{"Cos", "[", 
               RowBox[{"\[Theta]1", "+", "\[Theta]2"}], "]"}]}]}], "0"},
           {"0", "0", "0", "1"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
  "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"FixedJacobian", "[", 
     RowBox[{"Si_", ",", "\[Theta]i_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Js", ",", "n", ",", "Ti", ",", "Vs"}], "}"}], ",", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "Si", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Js", " ", "=", " ", 
        RowBox[{"Si", "[", 
         RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Ti", " ", "=", " ", 
           RowBox[{"IdentityMatrix", "[", "4", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{"Ti", "=", 
             RowBox[{
              RowBox[{"MatrixExp6", "[", 
               RowBox[{
                RowBox[{"Si", "[", 
                 RowBox[{"[", "jj", "]"}], "]"}], ",", 
                RowBox[{"\[Theta]i", "[", 
                 RowBox[{"[", "jj", "]"}], "]"}]}], "]"}], ".", "Ti"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"jj", ",", 
              RowBox[{"ii", "-", "1"}], ",", "1", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Vs", " ", "=", " ", 
           RowBox[{
            RowBox[{"Adjoint", "[", "Ti", "]"}], ".", 
            RowBox[{"Si", "[", 
             RowBox[{"[", "ii", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
          
          RowBox[{"Js", " ", "=", 
           RowBox[{"ArrayFlatten", "[", 
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"Js", ",", "Vs"}], "}"}], "}"}], "]"}]}], ";"}], 
         "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"ii", ",", "2", ",", "n"}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "Js", "]"}], ";"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"BodyJacobian", "[", 
       RowBox[{"Bi_", ",", "\[Theta]i_"}], "]"}], ":", "\[IndentingNewLine]", 
      
      RowBox[{
       RowBox[{
       "Takes", " ", "a", " ", "set", " ", "of", " ", "joint", " ", "angles", 
        " ", "\[Theta]i"}], " ", "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["R", "n"], " ", "and", " ", "a", " ", "set", " ", "of",
         " ", "screw", " ", "axes", " ", "Bi", " ", "for", " ", "the", " ", 
        "robot", " ", "joints", " ", "expressed", " ", "in", " ", "the", " ", 
        "body", " ", 
        RowBox[{"frame", ".", " ", "The"}], " ", "function", " ", "returns", 
        " ", "the", " ", "space", " ", "Jacobian", " ", 
        SubscriptBox["J", "b"], 
        RowBox[{"(", "\[Theta]", ")"}]}], " ", "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["R", 
         RowBox[{"6", "xn"}]], ".", "\[IndentingNewLine]", 
        "\[IndentingNewLine]", "Sample"}]}], ":", "\[IndentingNewLine]", "\t",
       "Input", ":"}], "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
     RowBox[{"B1", " ", "=", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
          RowBox[{"L1", "+", "L2"}], ",", "0"}], "}"}], "}"}], 
       "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"B2", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "L2", ",", "0"}], 
         "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"B3", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
         "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"B4", "=", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"{", 
         RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
         "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"B", "=", 
      RowBox[{"{", 
       RowBox[{"B1", ",", "B2", ",", "B3", ",", "B4"}], "}"}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Simplify", "[", 
       RowBox[{"BodyJacobian", "[", 
        RowBox[{"B", ",", 
         RowBox[{"{", 
          RowBox[{
          "\[Theta]1", ",", "\[Theta]2", ",", "\[Theta]3", ",", "\[Theta]4"}],
           "}"}]}], "]"}], "]"}], "//", 
      RowBox[{
      "MatrixForm", "\[IndentingNewLine]", "\[IndentingNewLine]", "\t", 
       RowBox[{"Output", ":", "\[IndentingNewLine]", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0", "0", "0", "0"},
            {"0", "0", "0", "0"},
            {"1", "1", "1", "0"},
            {
             RowBox[{
              RowBox[{"L2", " ", 
               RowBox[{"Sin", "[", "\[Theta]3", "]"}]}], "+", 
              RowBox[{"L1", " ", 
               RowBox[{"Sin", "[", 
                RowBox[{"\[Theta]2", "+", "\[Theta]3"}], "]"}]}]}], 
             RowBox[{"L2", " ", 
              RowBox[{"Sin", "[", "\[Theta]3", "]"}]}], "0", "0"},
            {
             RowBox[{
              RowBox[{"L2", " ", 
               RowBox[{"Cos", "[", "\[Theta]3", "]"}]}], "+", 
              RowBox[{"L1", " ", 
               RowBox[{"Cos", "[", 
                RowBox[{"\[Theta]2", "+", "\[Theta]3"}], "]"}]}]}], 
             RowBox[{"L2", " ", 
              RowBox[{"Cos", "[", "\[Theta]3", "]"}]}], "0", "0"},
            {"0", "0", "0", "1"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}]}]}], "\[IndentingNewLine]", 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"BodyJacobian", "[", 
     RowBox[{"Bi_", ",", "\[Theta]i_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Jb", ",", "n", ",", "Ti", ",", "Vs"}], "}"}], ",", 
      RowBox[{
       RowBox[{"n", "=", 
        RowBox[{"Length", "[", "Bi", "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Ti", " ", "=", " ", 
           RowBox[{"IdentityMatrix", "[", "4", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Do", "[", 
           RowBox[{
            RowBox[{"Ti", "=", 
             RowBox[{
              RowBox[{"MatrixExp6", "[", 
               RowBox[{
                RowBox[{"-", 
                 RowBox[{"Bi", "[", 
                  RowBox[{"[", "jj", "]"}], "]"}]}], ",", 
                RowBox[{"\[Theta]i", "[", 
                 RowBox[{"[", "jj", "]"}], "]"}]}], "]"}], ".", "Ti"}]}], ",", 
            RowBox[{"{", 
             RowBox[{"jj", ",", 
              RowBox[{"ii", "+", "1"}], ",", "n"}], "}"}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Vs", " ", "=", " ", 
           RowBox[{
            RowBox[{"Adjoint", "[", "Ti", "]"}], ".", 
            RowBox[{"Bi", "[", 
             RowBox[{"[", "ii", "]"}], "]"}]}]}], ";", "\[IndentingNewLine]", 
          
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{"ii", " ", "\[Equal]", " ", "1"}], ",", 
            RowBox[{"Jb", " ", "=", " ", "Vs"}], ",", "\[IndentingNewLine]", 
            RowBox[{"Jb", " ", "=", 
             RowBox[{"ArrayFlatten", "[", 
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{"Jb", ",", "Vs"}], "}"}], "}"}], "]"}]}]}], "]"}], 
          ";"}], "\[IndentingNewLine]", ",", 
         RowBox[{"{", 
          RowBox[{"ii", ",", "1", ",", 
           RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Vs", " ", "=", " ", 
        RowBox[{"Bi", "[", 
         RowBox[{"[", "n", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Jb", " ", "=", " ", 
        RowBox[{"ArrayFlatten", "[", 
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"Jb", ",", "Vs"}], "}"}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "Jb", "]"}], ";"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"IKinBody", "[", 
       RowBox[{
       "Bi_", ",", "M_", ",", "Tsd_", ",", "\[Theta]0_", ",", "\[Epsilon]w_", 
        ",", "\[Epsilon]v_"}], "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
      "Takes", " ", "a", " ", "set", " ", "of", " ", "screw", " ", "axes", 
       " ", 
       RowBox[{"(", "Bi", ")"}], " ", "for", " ", "the", " ", "robot", " ", 
       "joints", " ", "expressd", " ", "in", " ", "the", " ", "body", " ", 
       "frame"}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"the", " ", "end"}], "-", 
       RowBox[{"effector", " ", "zero", " ", "configuration", " ", "M"}]}], 
      " ", "\[Element]", " ", 
      RowBox[{"SE", 
       RowBox[{"(", "3", ")"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{"the", " ", "desired", " ", "end"}], "-", 
      RowBox[{"effector", " ", "configuration", " ", "Tsd"}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"an", " ", "initial", " ", "guess", " ", "\[Theta]0"}], " ", 
       "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["R", "n"], " ", "that", " ", "is", " ", "close", " ", 
        "to", " ", "satisfying", " ", "T", 
        RowBox[{"(", "\[Theta]0", ")"}]}]}], " ", "=", " ", "Tsd"}], ",", " ", 
     RowBox[{
     "and", " ", "values", " ", "controlling", " ", "how", " ", "close", " ", 
      "the", " ", "final", " ", "solution", " ", "\[Theta]k", " ", "must", 
      " ", "be", " ", "to", " ", "the", " ", "desired", " ", "answer", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Epsilon]w", " ", "and", " ", "\[Epsilon]v"}], ")"}], ".", 
       " ", "With"}], " ", "this", " ", "data"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "a", " ", "numerical", " ", "inverse", " ", "kinematics", " ", 
        "routine", " ", "based", " ", "on", " ", "Newton"}], "-", 
       RowBox[{"Raphson", " ", "is", " ", 
        RowBox[{"run", ".", " ", "The"}], " ", "function", " ", "returns", 
        " ", "a", " ", "matrix", " ", "of", " ", "joint", " ", "angles", " ", 
        "with", " ", "the", " ", "first", " ", "row", " ", "being", " ", 
        "the", " ", "inital", " ", "guess", " ", 
        RowBox[{"(", "\[Theta]0", ")"}], " ", "and", " ", "the", " ", "final",
         " ", "row", " ", "being", " ", "the", " ", "converged", " ", 
        "solution", " ", 
        RowBox[{
        "\[Theta]k", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Sample", ":", "\[IndentingNewLine]", "Input", ":"}]}]}]}], 
      "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
      RowBox[{"B1", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
           RowBox[{"1", "+", "2"}], ",", "0"}], "}"}], "}"}], 
        "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"B2", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "2", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"B3", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"B4", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"M", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", 
           RowBox[{"1", "+", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"B", "=", 
       RowBox[{"{", 
        RowBox[{"B1", ",", "B2", ",", "B3", ",", "B4"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Tsd", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", 
           RowBox[{"1", "+", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FullSimplify", "[", 
        RowBox[{"IKinBody", "[", 
         RowBox[{"B", ",", "M", ",", "Tsd", ",", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"Pi", "/", "2"}], ",", 
            RowBox[{"Pi", "/", "3"}], ",", "0", ",", "1"}], "}"}], ",", 
          ".001", ",", ".001"}], "]"}], "]"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "\t", 
       RowBox[{"Ouput", ":", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            FractionBox["\[Pi]", "2"], ",", 
            FractionBox["\[Pi]", "3"], ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{
            FractionBox["\[Pi]", "2"], ",", "0", ",", "0", ",", "0"}], 
           "}"}]}], "}"}]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"IKinBody", "[", 
     RowBox[{
     "Bi_", ",", "M_", ",", "Tsd_", ",", "\[Theta]0_", ",", "\[Epsilon]w_", 
      ",", "\[Epsilon]v_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"maxiter", " ", "=", " ", "100"}], ",", "\[Theta]i", ",", 
        "\[Theta]k", ",", "Tsb", ",", "Vb", ",", "Jb", ",", "n", ",", "m", 
        ",", "Jt"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Theta]i", " ", "=", " ", "\[Theta]0"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Theta]k", " ", "=", " ", 
        RowBox[{"{", "\[Theta]i", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Tsb", " ", "=", " ", 
        RowBox[{"FKinBody", "[", 
         RowBox[{"M", ",", "Bi", ",", "\[Theta]i"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Vb", " ", "=", " ", 
        RowBox[{"Simplify", "[", 
         RowBox[{"MatrixLog6", "[", 
          RowBox[{
           RowBox[{"TransInv", "[", "Tsb", "]"}], ".", "Tsd"}], "]"}], 
         "]"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"Vb", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "]"}], ">",
            "\[Epsilon]w"}], " ", "||", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"Vb", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "]"}], 
            ">", "\[Epsilon]v"}], " ", "&&", " ", 
           RowBox[{"i", " ", "<", "maxiter"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Jb", " ", "=", " ", 
           RowBox[{"BodyJacobian", "[", 
            RowBox[{"Bi", ",", "\[Theta]i"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"m", ",", "n"}], "}"}], " ", "=", " ", 
           RowBox[{"Dimensions", "[", "Jb", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Which", "[", 
           RowBox[{
            RowBox[{"n", ">", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{"Simplify", "[", 
              RowBox[{
               RowBox[{"Jb", "\[Transpose]"}], ".", 
               RowBox[{"Inverse", "[", 
                RowBox[{"(", 
                 RowBox[{"Jb", ".", 
                  RowBox[{"Jb", "\[Transpose]"}]}], ")"}], "]"}]}], "]"}]}], 
            ",", 
            RowBox[{"n", "<", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{"Simplify", "[", 
              RowBox[{
               RowBox[{"Inverse", "[", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"Jb", "\[Transpose]"}], ".", "Jb"}], ")"}], "]"}], 
               ".", 
               RowBox[{"Jb", "\[Transpose]"}]}], "]"}]}], ",", 
            RowBox[{"n", "\[Equal]", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{"Simplify", "[", 
              RowBox[{"Inverse", "[", "Jb", "]"}], "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Theta]i", "=", " ", 
           RowBox[{
            RowBox[{"Simplify", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", "\[Theta]i", "}"}], "\[Transpose]"}], " ", "+", 
                " ", 
                RowBox[{"Jt", ".", "Vb"}]}], ")"}], "\[Transpose]"}], "]"}], 
            "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Theta]k", " ", "=", " ", 
           RowBox[{"Insert", "[", 
            RowBox[{"\[Theta]k", ",", "\[Theta]i", ",", 
             RowBox[{"i", "+", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"i", "++"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Tsb", " ", "=", " ", 
           RowBox[{"FKinBody", "[", 
            RowBox[{"M", ",", "Bi", ",", "\[Theta]i"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Vb", " ", "=", " ", 
           RowBox[{"Simplify", "[", 
            RowBox[{"MatrixLog6", "[", 
             RowBox[{
              RowBox[{"Simplify", "[", 
               RowBox[{"TransInv", "[", "Tsb", "]"}], "]"}], ".", "Tsd"}], 
             "]"}], "]"}]}], ";"}]}], "\[IndentingNewLine]", "]"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "\[Theta]k", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"IKinFixed", "[", 
       RowBox[{
       "Si_", ",", "M_", ",", "Tsd_", ",", "\[Theta]0_", ",", "\[Epsilon]w_", 
        ",", "\[Epsilon]v_"}], "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
      "Takes", " ", "a", " ", "set", " ", "of", " ", "screw", " ", "axes", 
       " ", 
       RowBox[{"(", "Si", ")"}], " ", "for", " ", "the", " ", "robot", " ", 
       "joints", " ", "expressd", " ", "in", " ", "the", " ", "fixed", " ", 
       "frame"}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"the", " ", "end"}], "-", 
       RowBox[{"effector", " ", "zero", " ", "configuration", " ", "M"}]}], 
      " ", "\[Element]", " ", 
      RowBox[{"SE", 
       RowBox[{"(", "3", ")"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{"the", " ", "desired", " ", "end"}], "-", 
      RowBox[{"effector", " ", "configuration", " ", "Tsd"}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"an", " ", "initial", " ", "guess", " ", "\[Theta]0"}], " ", 
       "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["R", "n"], " ", "that", " ", "is", " ", "close", " ", 
        "to", " ", "satisfying", " ", "T", 
        RowBox[{"(", "\[Theta]0", ")"}]}]}], " ", "=", " ", "Tsd"}], ",", " ", 
     RowBox[{
     "and", " ", "values", " ", "controlling", " ", "how", " ", "close", " ", 
      "the", " ", "final", " ", "solution", " ", "\[Theta]k", " ", "must", 
      " ", "be", " ", "to", " ", "the", " ", "desired", " ", "answer", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"\[Epsilon]w", " ", "and", " ", "\[Epsilon]v"}], ")"}], ".", 
       " ", "With"}], " ", "this", " ", "data"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "a", " ", "numerical", " ", "inverse", " ", "kinematics", " ", 
        "routine", " ", "based", " ", "on", " ", "Newton"}], "-", 
       RowBox[{"Raphson", " ", "is", " ", 
        RowBox[{"run", ".", " ", "The"}], " ", "function", " ", "returns", 
        " ", "a", " ", "matrix", " ", "of", " ", "joint", " ", "angles", " ", 
        "with", " ", "the", " ", "first", " ", "row", " ", "being", " ", 
        "the", " ", "inital", " ", "guess", " ", 
        RowBox[{"(", "\[Theta]0", ")"}], " ", "and", " ", "the", " ", "final",
         " ", "row", " ", "being", " ", "the", " ", "converged", " ", 
        "solution", " ", 
        RowBox[{
        "\[Theta]k", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "Relevant"}], " ", 
        RowBox[{"Equations", ":", "\[IndentingNewLine]", 
         SubscriptBox["V", "s"]}]}]}], " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"[", 
         SubscriptBox["Ad", 
          SubscriptBox["T", "bs"]], "]"}], 
        RowBox[{
         SubscriptBox["V", "b"], ".", "\[IndentingNewLine]", 
         SubscriptBox["J", "b"]}]}], " ", "=", " ", 
       RowBox[{
        RowBox[{"[", 
         SubscriptBox["Ad", 
          SubscriptBox["T", "sb"]], "]"}], 
        SubscriptBox["J", "s"], "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "By", " ", "inputting", " ", 
        SubscriptBox["V", "s"], " ", "and", " ", 
        SubscriptBox["J", "s"], " ", "in", " ", "place", " ", "of", " ", 
        SubscriptBox["V", "b"], " ", "and", " ", 
        SubscriptBox["J", "b"]}]}]}], ",", " ", 
     RowBox[{
      RowBox[{
      "the", " ", "inverse", " ", "kinematics", " ", "can", " ", "be", " ", 
       "solved", " ", "in", " ", "the", " ", "fixed", " ", 
       RowBox[{"frame", ".", " ", "The"}], " ", "primary", " ", "update", " ",
        "equation", " ", "for", " ", "the", " ", "joint", " ", "angles", " ", 
       
       RowBox[{"becomes", ":", "\[IndentingNewLine]", 
        SubscriptBox["\[Theta]", 
         RowBox[{"i", "+", "1"}]]}]}], " ", "=", " ", 
      RowBox[{
       SubscriptBox["\[Theta]", "i"], " ", "+", " ", 
       RowBox[{"pseudoinverse", 
        RowBox[{"(", 
         RowBox[{
          SubscriptBox["J", "s"], 
          RowBox[{"(", 
           SubscriptBox["\[Theta]", "i"], ")"}]}], ")"}], 
        SubscriptBox["V", "s"]}]}]}], ",", " ", 
     RowBox[{
      RowBox[{"where", " ", 
       SubscriptBox["V", "s"]}], " ", "=", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"[", 
         SubscriptBox["Ad", 
          SubscriptBox["T", "bs"]], "]"}], 
        SubscriptBox["V", "b"], " ", "and", " ", 
        SubscriptBox["V", "b"]}], " ", "=", " ", 
       RowBox[{"log", 
        RowBox[{
         RowBox[{"(", 
          RowBox[{
           SuperscriptBox[
            SubscriptBox["T", "sb"], 
            RowBox[{"-", "1"}]], 
           RowBox[{"(", 
            SubscriptBox["\[Theta]", "i"], ")"}], 
           SubscriptBox["T", "sd"]}], ")"}], ".", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "By"}], " ", "multiplying", " ", 
        SubscriptBox["V", "b"], " ", 
        RowBox[{"by", " ", "[", 
         SubscriptBox["Ad", 
          SubscriptBox["T", "bs"]], "]"}], " ", "and", " ", 
        SubscriptBox["J", "b"], " ", 
        RowBox[{"by", " ", "[", 
         SubscriptBox["Ad", 
          SubscriptBox["T", "sb"]], "]"}]}]}]}], ",", " ", 
     RowBox[{"The", " ", "result", " ", "is", " ", 
      SubscriptBox["J", "s"], 
      RowBox[{"(", "Identity", ")"}], 
      SubscriptBox["V", "s"]}], ",", " ", 
     RowBox[{
      RowBox[{
      "thus", " ", "the", " ", "inverse", " ", "kinematics", " ", "in", " ", 
       "the", " ", "fixed", " ", "frame", " ", "yields", " ", "the", " ", 
       "same", " ", "result", " ", "as", " ", "for", " ", "the", " ", "body", 
       " ", 
       RowBox[{"frame", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sample", ":", "\[IndentingNewLine]", "Input", ":"}]}]}], 
      "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
      RowBox[{"S1", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"S2", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", "0"}], "}"}], "}"}], "\[Transpose]"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{"S3", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", 
           RowBox[{
            RowBox[{"-", "1"}], "-", "2"}], ",", "0"}], "}"}], "}"}], 
        "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"S4", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "0", ",", "1"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"S", "=", 
       RowBox[{"{", 
        RowBox[{"S1", ",", "S2", ",", "S3", ",", "S4"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"M", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", 
           RowBox[{"1", "+", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"Tsd", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", 
           RowBox[{"1", "+", "2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"IKinFixed", "[", 
        RowBox[{"S", ",", "M", ",", "Tsd", ",", ".001", ",", ".001"}], "]"}], 
       "\[IndentingNewLine]", "\[IndentingNewLine]", "\t", 
       RowBox[{"Output", ":", "\[IndentingNewLine]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            FractionBox["\[Pi]", "2"], ",", 
            FractionBox["\[Pi]", "3"], ",", "0", ",", "1"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{
             FractionBox["\[Pi]", "2"], ",", "0", ",", "0", ",", "0"}], "}"}],
            "}"}]}], "}"}]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"IKinFixed", "[", 
     RowBox[{
     "Si_", ",", "M_", ",", "Tsd_", ",", "\[Theta]0_", ",", "\[Epsilon]w_", 
      ",", "\[Epsilon]v_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", 
        RowBox[{"maxiter", " ", "=", " ", "100"}], ",", "\[Theta]i", ",", 
        "\[Theta]k", ",", "Tsb", ",", "Vs", ",", "Js", ",", "n", ",", "m", 
        ",", "Jt"}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"i", "=", "0"}], ";", "\[IndentingNewLine]", 
       RowBox[{"\[Theta]i", " ", "=", " ", "\[Theta]0"}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"\[Theta]k", " ", "=", " ", 
        RowBox[{"{", "\[Theta]i", "}"}]}], ";", "\[IndentingNewLine]", 
       RowBox[{"Tsb", " ", "=", " ", 
        RowBox[{"FKinFixed", "[", 
         RowBox[{"M", ",", "Si", ",", "\[Theta]i"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"Vs", " ", "=", " ", 
        RowBox[{
         RowBox[{"Adjoint", "[", "Tsb", "]"}], ".", 
         RowBox[{"MatrixLog6", "[", 
          RowBox[{
           RowBox[{"TransInv", "[", "Tsb", "]"}], ".", "Tsd"}], "]"}]}]}], 
       ";", "\[IndentingNewLine]", 
       RowBox[{"While", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"Norm", "[", 
            RowBox[{"Vs", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "]"}], ">",
            "\[Epsilon]w"}], " ", "||", " ", 
          RowBox[{
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"Vs", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "]"}], 
            ">", "\[Epsilon]v"}], " ", "&&", " ", 
           RowBox[{"i", " ", "<", "maxiter"}]}]}], ",", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"Js", " ", "=", 
           RowBox[{"FixedJacobian", "[", 
            RowBox[{"Si", ",", "\[Theta]i"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"m", ",", "n"}], "}"}], " ", "=", " ", 
           RowBox[{"Dimensions", "[", "Js", "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Which", "[", 
           RowBox[{
            RowBox[{"n", ">", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{
              RowBox[{"Js", "\[Transpose]"}], ".", 
              RowBox[{"Inverse", "[", 
               RowBox[{"(", 
                RowBox[{"Js", ".", 
                 RowBox[{"Js", "\[Transpose]"}]}], ")"}], "]"}]}]}], ",", 
            RowBox[{"n", "<", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{
              RowBox[{"Inverse", "[", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"Js", "\[Transpose]"}], ".", "Js"}], ")"}], "]"}], 
              ".", 
              RowBox[{"Js", "\[Transpose]"}]}]}], ",", 
            RowBox[{"n", "\[Equal]", "m"}], ",", 
            RowBox[{"Jt", " ", "=", " ", 
             RowBox[{"Inverse", "[", "Js", "]"}]}]}], "]"}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"\[Theta]i", "=", " ", 
           RowBox[{
            RowBox[{"Simplify", "[", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                RowBox[{
                 RowBox[{"{", "\[Theta]i", "}"}], "\[Transpose]"}], " ", "+", 
                " ", 
                RowBox[{"Jt", ".", "Vs"}]}], ")"}], "\[Transpose]"}], "]"}], 
            "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"\[Theta]k", " ", "=", " ", 
           RowBox[{"Insert", "[", 
            RowBox[{"\[Theta]k", ",", "\[Theta]i", ",", 
             RowBox[{"i", "+", "2"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
          RowBox[{"i", "++"}], ";", "\[IndentingNewLine]", 
          RowBox[{"Tsb", " ", "=", " ", 
           RowBox[{"FKinFixed", "[", 
            RowBox[{"M", ",", "Si", ",", "\[Theta]i"}], "]"}]}], ";", 
          "\[IndentingNewLine]", 
          RowBox[{"Vs", " ", "=", "  ", 
           RowBox[{
            RowBox[{"Adjoint", "[", "Tsb", "]"}], ".", 
            RowBox[{"MatrixLog6", "[", 
             RowBox[{
              RowBox[{"TransInv", "[", "Tsb", "]"}], ".", "Tsd"}], "]"}]}]}], 
          ";"}]}], "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "\[Theta]k", "]"}], ";"}]}], 
     "\[IndentingNewLine]", "]"}]}], "\[IndentingNewLine]"}]}]], "Input",
 CellChangeTimes->{{3.655303749054861*^9, 3.655303837243351*^9}, {
   3.655303935892049*^9, 3.65530400463916*^9}, {3.655304062550365*^9, 
   3.655304084346537*^9}, {3.6553041677511253`*^9, 3.6553041790102386`*^9}, {
   3.6553043087061577`*^9, 3.655304356487946*^9}, {3.6553045760201797`*^9, 
   3.655304621688348*^9}, {3.655304672254786*^9, 3.655304703140993*^9}, {
   3.655304733626122*^9, 3.655304750721487*^9}, {3.655304797348097*^9, 
   3.65530486345516*^9}, {3.655304898926793*^9, 3.655304899367713*^9}, {
   3.655304934811789*^9, 3.655305074033688*^9}, {3.655305133736866*^9, 
   3.655305141249852*^9}, {3.655305237646421*^9, 3.655305257207346*^9}, {
   3.6553053045865297`*^9, 3.655305314680172*^9}, {3.6553054210858917`*^9, 
   3.655305869038018*^9}, {3.655306006451118*^9, 3.6553060223775473`*^9}, {
   3.655306076273017*^9, 3.655306082699461*^9}, {3.655306130670807*^9, 
   3.655306169098173*^9}, {3.65530625917485*^9, 3.655306268373435*^9}, {
   3.655306317725618*^9, 3.655306388875993*^9}, {3.6553064450582657`*^9, 
   3.655306446409431*^9}, {3.65530649013*^9, 3.655306490720007*^9}, {
   3.65530654770545*^9, 3.655306610224576*^9}, {3.655306917919043*^9, 
   3.65530692408035*^9}, {3.655307107922289*^9, 3.655307108227564*^9}, {
   3.655307421398878*^9, 3.655307521580522*^9}, {3.655307597275941*^9, 
   3.655307721459166*^9}, {3.655307775127255*^9, 3.655307849088579*^9}, {
   3.6553081721034737`*^9, 3.6553081838304462`*^9}, {3.655308223567062*^9, 
   3.6553082416666403`*^9}, {3.655309131815096*^9, 3.655309135398634*^9}, {
   3.655309205310437*^9, 3.6553092090069733`*^9}, {3.655309258125122*^9, 
   3.655309280388904*^9}, {3.65530933690707*^9, 3.6553093621638308`*^9}, {
   3.655309425897483*^9, 3.655309450955587*^9}, {3.655309544336773*^9, 
   3.655309544688896*^9}, {3.655310878284791*^9, 3.655311068006097*^9}, {
   3.655311106074193*^9, 3.655311334271719*^9}, {3.6553113679478207`*^9, 
   3.65531139334953*^9}, {3.655311442394168*^9, 3.655311802172915*^9}, {
   3.655312113269909*^9, 3.655312178149*^9}, {3.655312217160633*^9, 
   3.655312303338461*^9}, {3.6553123710626907`*^9, 3.655312442106433*^9}, {
   3.655312473300489*^9, 3.655312528129603*^9}, {3.655312697113574*^9, 
   3.655312706440462*^9}, {3.65531284693782*^9, 3.655312847407776*^9}, {
   3.655313041645165*^9, 3.655313121770051*^9}, {3.6553133591785603`*^9, 
   3.65531338948073*^9}, {3.6553143795528107`*^9, 3.655314382967433*^9}, {
   3.6553144449438877`*^9, 3.6553144975821543`*^9}, {3.655314575885811*^9, 
   3.65531457680399*^9}, {3.6553146446570263`*^9, 3.655314719735477*^9}, {
   3.655314807305623*^9, 3.65531481964889*^9}, {3.655315012692184*^9, 
   3.655315015746052*^9}, {3.655315058985021*^9, 3.655315087403203*^9}, {
   3.655315831034155*^9, 3.655315859951062*^9}, {3.655315894735524*^9, 
   3.6553159022785254`*^9}, {3.655316145852942*^9, 3.655316148973249*^9}, {
   3.655316490484427*^9, 3.655316547033306*^9}, {3.6553165879876823`*^9, 
   3.655316611330742*^9}, {3.65531664454352*^9, 3.65531667804449*^9}, {
   3.65531672127104*^9, 3.655316751462372*^9}, {3.655316782176889*^9, 
   3.655316832566299*^9}, {3.655316863406324*^9, 3.6553171502207193`*^9}, {
   3.65531722511699*^9, 3.655317284828404*^9}, {3.65531732354044*^9, 
   3.65531735540726*^9}, {3.655317411045854*^9, 3.6553174201819487`*^9}, {
   3.655317527741452*^9, 3.6553175382684727`*^9}, {3.655317675960969*^9, 
   3.6553177022133303`*^9}, {3.655317964406609*^9, 3.655317983454211*^9}, {
   3.6553180193036337`*^9, 3.6553180605796833`*^9}, {3.655326599781858*^9, 
   3.6553266774581614`*^9}, {3.6553267352606583`*^9, 3.655326772554593*^9}, {
   3.655326902561502*^9, 3.655326903650279*^9}, {3.655327931474889*^9, 
   3.655327940906636*^9}, {3.655328028965217*^9, 3.655328042301713*^9}, {
   3.6553280736778517`*^9, 3.6553280798055153`*^9}, {3.655329898428473*^9, 
   3.6553299272887497`*^9}, {3.655331271139799*^9, 3.655331276122501*^9}, {
   3.655335825732477*^9, 3.65533583261871*^9}, {3.6553358937026043`*^9, 
   3.655335893939856*^9}, 3.655347964197816*^9, {3.655420914977571*^9, 
   3.655420922471732*^9}, {3.6554215288839293`*^9, 3.655421529154537*^9}, {
   3.655421631740293*^9, 3.655421662645466*^9}, {3.6554218616059303`*^9, 
   3.655421876989644*^9}, {3.6554219591896763`*^9, 3.655421961332955*^9}, {
   3.6554220596792803`*^9, 3.655422119725775*^9}, {3.655422182361636*^9, 
   3.655422263437512*^9}, {3.6554223000154448`*^9, 3.655422315053005*^9}, {
   3.655422416905715*^9, 3.65542243328547*^9}, {3.655422589455029*^9, 
   3.655422597534828*^9}, {3.655422728128405*^9, 3.655422729758772*^9}, {
   3.6554228806763363`*^9, 3.6554228837319517`*^9}, {3.655471320792515*^9, 
   3.655471323511464*^9}, {3.655471359855755*^9, 3.655471388374826*^9}, {
   3.655471427245632*^9, 3.6554714613883*^9}, {3.655471564257729*^9, 
   3.6554715686337643`*^9}, {3.655472301053514*^9, 3.655472303396009*^9}, {
   3.655515302862877*^9, 3.6555153036288757`*^9}, {3.6560973203257*^9, 
   3.656097423841917*^9}, {3.656097457345387*^9, 3.65609745759276*^9}, {
   3.656098816212549*^9, 3.656098936962525*^9}, {3.656099195930627*^9, 
   3.656099257043271*^9}, {3.656099565321022*^9, 3.656099843802733*^9}, {
   3.656099882700592*^9, 3.656099905989571*^9}, {3.656099940877697*^9, 
   3.656100004957464*^9}, {3.656100037456994*^9, 3.65610017347542*^9}, {
   3.65610027874212*^9, 3.65610030937967*^9}, {3.656100467252062*^9, 
   3.656100515460945*^9}, {3.656100594885799*^9, 3.6561006278625383`*^9}, {
   3.656100715360955*^9, 3.656100726984631*^9}, {3.6561009554169693`*^9, 
   3.656101076714023*^9}, {3.656101177866333*^9, 3.65610124930823*^9}, {
   3.656101376684906*^9, 3.6561014714995527`*^9}}],

Cell[CellGroupData[{

Cell["\<\
Code from Assignment 2 that may be used in the above functions can be found \
by expanding the tab to the right\
\>", "Subsubsection",
 CellChangeTimes->{{3.656120229798893*^9, 3.656120253284745*^9}, {
  3.656120732624467*^9, 3.656120745510766*^9}, {3.656120779149761*^9, 
  3.656120779901783*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"(*", 
   RowBox[{
    RowBox[{
     RowBox[{"RotInv", "[", "R_", "]"}], ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Takes", " ", "a", " ", "rotation", " ", "matrix", " ", 
       RowBox[{"(", "R", ")"}]}], " ", "\[Element]", " ", 
      RowBox[{"SO", 
       RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", "its", " ", 
       RowBox[{"inverse", ".", "  ", "The"}], " ", "function", " ", "checks", 
       " ", "to", " ", "see", " ", "if", " ", "the", " ", "input", " ", "is", 
       " ", "valid", " ", "rotation", " ", "matrix", " ", "and", " ", "if", 
       " ", "it", " ", "is", " ", "will", " ", "return", " ", "its", " ", 
       RowBox[{"inverse", ".", "  ", "If"}], " ", "it", " ", "is", " ", 
       "invalid"}]}]}], ",", " ", 
    RowBox[{"an", " ", "error", " ", "will", " ", "be", " ", 
     RowBox[{"returned", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Sample", ":", "\[IndentingNewLine]", "Input", ":", " ", 
       RowBox[{
        RowBox[{"RotInv", "[", 
         RowBox[{"RotationMatrix", "[", 
          RowBox[{
           RowBox[{"Pi", "/", "2"}], ",", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0"}], "}"}]}], "]"}], "]"}], 
        "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}]}], "}"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "Input"}], ":", " ", 
         RowBox[{
          RowBox[{"RotInv", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "2", ",", "0"}], "}"}], ",", 
             RowBox[{"{", 
              RowBox[{"1", ",", "9", ",", "3"}], "}"}]}], "}"}], "]"}], 
          "\[IndentingNewLine]", 
          RowBox[{"Output", ":", " ", "Error"}]}]}]}]}]}]}]}], 
   "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{
    RowBox[{"RotInv", "[", "R_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "}"}], ",", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"R", "\[Transpose]"}], ".", "R"}], "\[Equal]", 
          RowBox[{"IdentityMatrix", "[", "3", "]"}]}], " ", "&&", " ", 
         RowBox[{
          RowBox[{"Det", "[", "R", "]"}], "\[Equal]", "1"}]}], ",", 
        RowBox[{"R", "\[Transpose]"}], ",", 
        RowBox[{"Print", "[", "\"\<Error\>\"", "]"}]}], "]"}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"VecToso3", "[", "\[Omega]_", "]"}], ":", "\[IndentingNewLine]", 
     
     RowBox[{
      RowBox[{"Takes", " ", "a", " ", "3"}], "-", 
      RowBox[{"vector", " ", 
       RowBox[{"(", "\[Omega]", ")"}], " ", "and", " ", "returns", " ", "the",
        " ", "3", " ", "x", " ", "3", " ", "skew"}], "-", 
      RowBox[{"symmetric", " ", "matrix", " ", "version", " ", 
       RowBox[{
        RowBox[{"(", 
         RowBox[{"so", 
          RowBox[{"(", "3", ")"}]}], ")"}], ".", "  ", "The"}], " ", "input", 
       " ", "vector", " ", "is", " ", "a", " ", "column", " ", "vector", " ", 
       "representing", " ", "angular", " ", 
       RowBox[{
       "velocity", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "Sample"}]}]}], ":", "\[IndentingNewLine]", "Input", ":", " ", 
     RowBox[{
      RowBox[{"VecToso3", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"1", ",", "2", ",", "3"}], "}"}], "}"}], "\[Transpose]"}], 
       "]"}], "\[IndentingNewLine]", 
      RowBox[{"Output", ":", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "3"}], ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "2"}], ",", "1", ",", "0"}], "}"}]}], "}"}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"VecToso3", "[", "\[Omega]_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", 
         RowBox[{"\[Omega]", "[", 
          RowBox[{"[", 
           RowBox[{"3", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"\[Omega]", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Omega]", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "1"}], "]"}], "]"}], ",", "0", ",", 
        RowBox[{"-", 
         RowBox[{"\[Omega]", "[", 
          RowBox[{"[", 
           RowBox[{"1", ",", "1"}], "]"}], "]"}]}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", 
         RowBox[{"\[Omega]", "[", 
          RowBox[{"[", 
           RowBox[{"2", ",", "1"}], "]"}], "]"}]}], ",", 
        RowBox[{"\[Omega]", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "1"}], "]"}], "]"}], ",", "0"}], "}"}]}], "}"}]}],
    "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"so3ToVec", "[", "\[Omega]skew_", "]"}], ":", 
     "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
       RowBox[{"Takes", " ", "a", " ", "3", " ", "x", " ", "3", " ", "skew"}],
        "-", 
       RowBox[{"symmetric", " ", "matrix", " ", 
        RowBox[{"(", "\[Omega]skew", ")"}]}]}], " ", "\[Element]", " ", 
      RowBox[{
       RowBox[{"so", 
        RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", "a", " ", 
        "3"}], "-", 
       RowBox[{
       "vector", " ", "version", " ", "representing", " ", "the", " ", 
        "angular", " ", 
        RowBox[{
        "velocity", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "Sample"}]}]}]}], ":", "\[IndentingNewLine]", "Input", ":", " ", 
     RowBox[{
      RowBox[{"so3ToVec", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", 
           RowBox[{"-", "3"}], ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"3", ",", "0", ",", 
           RowBox[{"-", "1"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "2"}], ",", "1", ",", "0"}], "}"}]}], "}"}], "]"}], 
      "\[IndentingNewLine]", 
      RowBox[{"Output", ":", " ", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", 
         RowBox[{"{", "2", "}"}], ",", 
         RowBox[{"{", "3", "}"}]}], "}"}]}]}]}], "\[IndentingNewLine]", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"so3ToVec", "[", "\[Omega]skew_", "]"}], ":=", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"\[Omega]skew", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"\[Omega]skew", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"\[Omega]skew", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}]}], "}"}], "}"}], 
     "\[Transpose]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"AxisAng3", "[", "r_", "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Takes", " ", "a", " ", "3"}], "-", 
       RowBox[{"vector", " ", 
        RowBox[{"(", "r", ")"}], " ", "of", " ", "exponential", " ", 
        "coordinates", " ", "for", " ", "rotation", " ", "and", " ", 
        "returns", " ", "the", " ", "unit", " ", "rotation", " ", "axis", " ", 
        OverscriptBox["\[Omega]", "^"], " ", "and", " ", "the", " ", "amount",
         " ", "of", " ", "rotation", " ", "\[Theta]", " ", "where", " ", 
        "r"}]}]}], " ", "=", " ", 
     RowBox[{
      OverscriptBox["\[Omega]", "^"], 
      RowBox[{"\[Theta]", ".", "  ", "The"}], " ", "first", " ", "element", 
      " ", "of", " ", "the", " ", "output", " ", "is", " ", "the", " ", 
      "unit", " ", "rotation", " ", "axis", " ", "column", " ", "vector", " ",
       "and", " ", "the", " ", "second", " ", "element", " ", "is", " ", 
      RowBox[{"\[Theta]", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Sample", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{
         RowBox[{"AxisAng3", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Pi", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}], ",", 
              RowBox[{"Pi", "/", 
               RowBox[{"Sqrt", "[", "2", "]"}]}], ",", "0"}], "}"}], "}"}], 
           "\[Transpose]"}], "]"}], "\[IndentingNewLine]", 
         RowBox[{"Output", ":", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               FractionBox["1", 
                SqrtBox["2"]], "}"}], ",", 
              RowBox[{"{", 
               FractionBox["1", 
                SqrtBox["2"]], "}"}], ",", 
              RowBox[{"{", "0", "}"}]}], "}"}], ",", "\[Pi]"}], 
           "}"}]}]}]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AxisAng3", "[", "r_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"r", "/", 
       RowBox[{"Norm", "[", "r", "]"}]}], ",", 
      RowBox[{"Norm", "[", "r", "]"}]}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"MatrixExp3", "[", 
       RowBox[{"\[Omega]hat_", ",", "\[Theta]_"}], "]"}], ":", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Takes", " ", "a", " ", "3"}], "-", 
        RowBox[{
        "vector", " ", "of", " ", "exponential", " ", "coordinates", " ", 
         "broken", " ", "up", " ", "into", " ", "a", " ", "unit", " ", 
         "rotation", " ", "axis", " ", 
         OverscriptBox["\[Omega]", "^"], " ", "and", " ", "a", " ", 
         "rotation", " ", "about", " ", "that", " ", "axis", " ", "\[Theta]", 
         " ", "and", " ", "returns", " ", 
         RowBox[{"R", "'"}]}]}], " ", "\[Element]", " ", 
       RowBox[{"SO", 
        RowBox[{"(", "3", ")"}], " ", "that", " ", "is", " ", "achieved", " ",
         "by", " ", "rotating", " ", "about", " ", 
        OverscriptBox["\[Omega]", "^"], " ", "by", " ", "a", " ", "distance", 
        " ", "\[Theta]", " ", "from", " ", "an", " ", "initial", " ", 
        "orientation", " ", "R"}]}]}], " ", "=", " ", 
     RowBox[{
      RowBox[{"I", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
       RowBox[{"Sample", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{"MatrixExp3", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"{", 
            RowBox[{"{", 
             RowBox[{"0", ",", ".866", ",", ".5"}], "}"}], "}"}], 
           "\[Transpose]"}], ",", 
          RowBox[{"30", " ", "Degree"}]}], "]"}]}]}], "//", 
      RowBox[{"MatrixForm", "\[IndentingNewLine]", 
       RowBox[{"Output", ":", " ", 
        TagBox[
         RowBox[{"(", "\[NoBreak]", GridBox[{
            {"0.8660312986666721", 
             RowBox[{"-", "0.25"}], "0.433"},
            {"0.25", "0.9665063509461096", "0.05801100016133809"},
            {
             RowBox[{"-", "0.433"}], "0.05801100016133809", 
             "0.8995249477205625"}
           },
           
           GridBoxAlignment->{
            "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
             "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
           GridBoxSpacings->{"Columns" -> {
               Offset[0.27999999999999997`], {
                Offset[0.7]}, 
               Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
               Offset[0.2], {
                Offset[0.4]}, 
               Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
         Function[BoxForm`e$, 
          MatrixForm[BoxForm`e$]]]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixExp3", "[", 
     RowBox[{"\[Omega]hat_", ",", "\[Theta]_"}], "]"}], ":=", 
    RowBox[{
     RowBox[{"IdentityMatrix", "[", "3", "]"}], "+", 
     RowBox[{
      RowBox[{"Sin", "[", "\[Theta]", "]"}], "*", 
      RowBox[{"VecToso3", "[", "\[Omega]hat", "]"}]}], "+", 
     RowBox[{
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}], "*", 
      RowBox[{"MatrixPower", "[", 
       RowBox[{
        RowBox[{"VecToso3", "[", "\[Omega]hat", "]"}], ",", "2"}], 
       "]"}]}]}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"MatrixLog3", "[", "R_", "]"}], ":", 
                  "\[IndentingNewLine]", 
                  RowBox[{
                   RowBox[{
                   "Takes", " ", "a", " ", "rotation", " ", "matrix", " ", 
                    RowBox[{"(", "R", ")"}]}], " ", "\[Element]", " ", 
                   RowBox[{
                    RowBox[{"SO", 
                    RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", 
                    "the", " ", "corresponding", " ", "3"}], "-", 
                    RowBox[{
                    "vector", " ", "of", " ", "exponential", " ", 
                    "coordinates", " ", "r"}]}]}]}], ",", " ", 
                 RowBox[{
                  RowBox[{"where", " ", "r"}], " ", "=", " ", 
                  RowBox[{
                   OverscriptBox["\[Omega]", "^"], 
                   RowBox[{"\[Theta]", ".", "  ", "This"}], " ", "function", 
                   " ", "considers", " ", "3", " ", 
                   RowBox[{"cases", ":", "\[IndentingNewLine]", "i"}]}]}]}], 
                ")"}], " ", "If", " ", "R"}], " ", "=", " ", 
              RowBox[{"I", " ", 
               RowBox[{"(", 
                RowBox[{
                 RowBox[{"i", ".", "e", ".", " ", "\[Theta]"}], " ", "=", " ",
                  "0"}], ")"}]}]}], ",", " ", 
             RowBox[{
             "the", " ", "function", " ", "will", " ", "return", " ", 
              "\"\<undefined - no rotation\>\"", " ", "as", " ", "nothing", 
              " ", "moved", " ", "in", " ", "this", " ", 
              RowBox[{
              "instance", ".", "  ", "\[IndentingNewLine]", "ii"}]}]}], ")"}],
            " ", "If", " ", 
           RowBox[{"Tr", "[", "R", "]"}]}], " ", "=", " ", 
          RowBox[{"-", "1"}]}], ",", " ", 
         RowBox[{"\[Theta]", " ", "=", " ", 
          RowBox[{
          "\[Pi]", " ", "and", " ", "the", " ", "function", " ", "will", " ", 
           "check", " ", "three", " ", "different", " ", "cases", " ", "to", 
           " ", "determine", " ", "which", " ", "is", " ", "the", " ", 
           "feasible", " ", "solution", " ", 
           RowBox[{"vector", ".", "  ", "\[IndentingNewLine]", "iii"}]}]}]}], 
        ")"}], " ", "If", " ", "\[Theta]"}], " ", "\[NotEqual]", " ", 
      RowBox[{"0", " ", "or", " ", "\[Pi]"}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{"the", " ", "solution", " ", "is", " ", "well"}], "-", 
       RowBox[{
       "defined", " ", "and", " ", "the", " ", "function", " ", "will", " ", 
        "output", " ", "an", " ", 
        RowBox[{"r", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Samples", ":"}]}]}]}], "\[IndentingNewLine]", ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Case", " ", 
       RowBox[{"i", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{
         RowBox[{"MatrixLog3", "[", 
          RowBox[{"IdentityMatrix", "[", "3", "]"}], "]"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Output", ":", " ", 
          RowBox[{"{", 
           RowBox[{"\"\<undefined - no rotation\>\"", ",", "0"}], 
           "}"}]}]}]}]}], ";", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Case", " ", 
       RowBox[{"ii", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{
         RowBox[{"MatrixLog3", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"1", ",", "0", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "1"}], ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0", ",", 
              RowBox[{"-", "1"}]}], "}"}]}], "}"}], "]"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Output", ":", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "\[Pi]", "}"}], ",", 
            RowBox[{"{", "0", "}"}], ",", 
            RowBox[{"{", "0", "}"}]}], "}"}]}]}]}]}], ";", 
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Case", " ", 
       RowBox[{"iii", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{
         RowBox[{"MatrixLog3", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              FractionBox["1", "2"], ",", 
              FractionBox["1", "2"], ",", 
              FractionBox["1", 
               SqrtBox["2"]]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              FractionBox["1", "2"], ",", 
              FractionBox["1", "2"], ",", 
              RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}]}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"-", 
               FractionBox["1", 
                SqrtBox["2"]]}], ",", 
              FractionBox["1", 
               SqrtBox["2"]], ",", "0"}], "}"}]}], "}"}], "]"}], 
         "\[IndentingNewLine]", 
         RowBox[{"Output", ":", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             FractionBox["\[Pi]", 
              RowBox[{"2", " ", 
               SqrtBox["2"]}]], "}"}], ",", 
            RowBox[{"{", 
             FractionBox["\[Pi]", 
              RowBox[{"2", " ", 
               SqrtBox["2"]}]], "}"}], ",", 
            RowBox[{"{", "0", "}"}]}], "}"}]}]}]}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixLog3", "[", "R_", "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"out", ",", "\[Theta]"}], "}"}], ",", 
      RowBox[{
       RowBox[{"\[Theta]", "=", 
        RowBox[{"ArcCos", "[", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{"Tr", "[", "R", "]"}], "-", "1"}], ")"}], "/", "2"}], 
         "]"}]}], ";", 
       RowBox[{"Which", "[", 
        RowBox[{
         RowBox[{"\[Theta]", "\[Equal]", "0"}], ",", 
         RowBox[{"out", "=", 
          RowBox[{"{", 
           RowBox[{"\"\<undefined - no rotation\>\"", ",", "0"}], "}"}]}], 
         ",", 
         RowBox[{
          RowBox[{"Tr", "[", "R", "]"}], "\[Equal]", 
          RowBox[{"-", "1"}]}], ",", 
         RowBox[{"Which", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"R", "[", 
              RowBox[{"[", 
               RowBox[{"3", ",", "3"}], "]"}], "]"}]}], "\[NotEqual]", " ", 
            "0"}], ",", 
           RowBox[{"out", "=", 
            RowBox[{
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"2", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
              "*", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", 
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}]}], "}"}], "}"}], 
              "\[Transpose]"}], "*", "Pi"}]}], ",", 
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"R", "[", 
              RowBox[{"[", 
               RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "\[NotEqual]", "0"}], 
           ",", 
           RowBox[{"out", "=", 
            RowBox[{
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"2", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
              "*", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", 
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], 
              "\[Transpose]"}], "*", "Pi"}]}], ",", 
           RowBox[{
            RowBox[{"1", "+", 
             RowBox[{"R", "[", 
              RowBox[{"[", 
               RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "\[NotEqual]", " ", 
            "0"}], ",", 
           RowBox[{"out", "=", 
            RowBox[{
             RowBox[{"1", "/", 
              RowBox[{"Sqrt", "[", 
               RowBox[{"2", 
                RowBox[{"(", 
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
              "*", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"1", "+", 
                  RowBox[{"R", "[", 
                   RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
                 RowBox[{"R", "[", 
                  RowBox[{"[", 
                   RowBox[{"3", ",", "1"}], "]"}], "]"}]}], "}"}], "}"}], 
              "\[Transpose]"}], "*", "Pi"}]}]}], "]"}], ",", 
         RowBox[{
          RowBox[{"\[Theta]", "\[NotEqual]", "0"}], "&&", 
          RowBox[{
           RowBox[{"Tr", "[", "R", "]"}], "\[NotEqual]", 
           RowBox[{"-", "1"}]}]}], ",", 
         RowBox[{"out", "=", 
          RowBox[{
           RowBox[{"so3ToVec", "[", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"R", "-", 
               RowBox[{"R", "\[Transpose]"}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"2", "*", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}], "]"}], "*", 
           "\[Theta]"}]}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "out", "]"}]}]}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"RpToTrans", "[", 
       RowBox[{"R_", ",", "p_"}], "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Takes", " ", "a", " ", "rotation", " ", "matrix", " ", "R"}], 
       " ", "\[Element]", " ", 
       RowBox[{"SO", 
        RowBox[{"(", "3", ")"}], " ", "and", " ", "a", " ", "position", " ", 
        "p"}], " ", "\[Element]", " ", 
       RowBox[{
        SuperscriptBox["R", "3"], " ", "and", " ", "returns", " ", "the", " ",
         "corresponding", " ", "homogenous", " ", "transformation", " ", 
        "matrix", " ", "T"}], " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{
         RowBox[{"(", "3", ")"}], ".", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "Sample"}]}]}], ":", "\[IndentingNewLine]", 
      "\t", "Input", ":", " ", 
      RowBox[{"RpToTrans", "[", 
       RowBox[{
        RowBox[{"RotationMatrix", "[", 
         RowBox[{
          RowBox[{"Pi", "/", "2"}], ",", 
          RowBox[{"{", 
           RowBox[{"0", ",", "1", ",", "0"}], "}"}]}], "]"}], ",", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"{", 
           RowBox[{"2", ",", "3", ",", "4"}], "}"}], "}"}], 
         "\[Transpose]"}]}], "]"}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", "\t", 
      RowBox[{"Output", ":", " ", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0", "1", "2"},
           {"0", "1", "0", "3"},
           {
            RowBox[{"-", "1"}], "0", "0", "4"},
           {"0", "0", "0", "1"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"RpToTrans", "[", 
     RowBox[{"R_", ",", "p_"}], "]"}], ":=", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"R", ",", "p"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"TransToRp", "[", "T_", "]"}], ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "Takes", " ", "a", " ", "transformation", " ", "matrix", " ", "T"}], 
      " ", "\[Element]", " ", 
      RowBox[{"SE", 
       RowBox[{"(", "3", ")"}], " ", "and", " ", "reutns", " ", "the", " ", 
       "corresponding", " ", "rotation", " ", "matrix", " ", "R"}], " ", 
      "\[Element]", " ", 
      RowBox[{"SO", 
       RowBox[{"(", "3", ")"}], " ", "and", " ", "position", " ", "vector", 
       " ", "p", " ", "\[Epsilon]", " ", 
       RowBox[{
        SuperscriptBox["R", "3"], ".", "  ", "The"}], " ", "first", " ", 
       "element", " ", "of", " ", "the", " ", "output", " ", "is", " ", "the",
        " ", "rotation", " ", "matrix", " ", "and", " ", "the", " ", "second",
        " ", "is", " ", "the", " ", "position", " ", 
       RowBox[{
       "vector", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "Sample"}]}]}], ":", "\[IndentingNewLine]", "\t", "Input", ":", " ", 
     RowBox[{
      RowBox[{"TransToRp", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], "]"}], 
      "\[IndentingNewLine]", "\t", "Output"}], ":", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0"}], "}"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "2", "}"}], ",", 
         RowBox[{"{", "3", "}"}], ",", 
         RowBox[{"{", "4", "}"}]}], "}"}]}], "}"}]}], "\[IndentingNewLine]", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TransToRp", "[", "T_", "]"}], ":=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"T", "[", 
       RowBox[{"[", 
        RowBox[{
         RowBox[{"1", ";;", "3"}], ",", 
         RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], ",", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"T", "[", 
         RowBox[{"[", 
          RowBox[{
           RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}], "}"}], 
       "\[Transpose]"}]}], "}"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"TransInv", "[", "T_", "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "Takes", " ", "a", " ", "transformation", " ", "matrix", " ", "T"}], 
       " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", "its", " ", 
        
        RowBox[{
        "inverse", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         "Sample"}]}]}], ":", "\[IndentingNewLine]", "\t", "Input", ":", " ", 
      
      RowBox[{"TransInv", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
       "]"}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", "\t", 
      RowBox[{"Output", ":", " ", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0", 
            RowBox[{"-", "1"}], "4"},
           {"0", "1", "0", 
            RowBox[{"-", "3"}]},
           {"1", "0", "0", 
            RowBox[{"-", "2"}]},
           {"0", "0", "0", "1"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"TransInv", "[", "T_", "]"}], ":=", "\[IndentingNewLine]", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"T", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "3"}], ",", 
             RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "\[Transpose]"}], ",", 
         
         RowBox[{"-", 
          RowBox[{
           RowBox[{
            RowBox[{"T", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", 
               RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "\[Transpose]"}], 
           ".", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"T", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}], "}"}], 
            "\[Transpose]"}]}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"VecTose3", "[", "V_", "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Takes", " ", "a", " ", "6"}], "-", 
        RowBox[{"vector", " ", 
         RowBox[{"(", "V", ")"}], " ", "representing", " ", "a", " ", 
         "spatial", " ", "velocity", " ", "and", " ", "returns", " ", "the", 
         " ", "corresponding", " ", "4", " ", "x", " ", "4", " ", 
         "matrix"}]}], " ", "\[Element]", " ", 
       RowBox[{"se", 
        RowBox[{
         RowBox[{"(", "3", ")"}], ".", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "Sample"}]}]}], ":", "\[IndentingNewLine]", 
      "\t", "Input", ":", " ", 
      RowBox[{"VecTose3", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"1", ",", "0", ",", "0", ",", "2", ",", "3", ",", "4"}], 
          "}"}], "}"}], "\[Transpose]"}], "]"}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", "\t", 
      RowBox[{"Output", ":", " ", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0", "0", "2"},
           {"0", "0", 
            RowBox[{"-", "1"}], "3"},
           {"0", "1", "0", "4"},
           {"0", "0", "0", "0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"VecTose3", "[", "V_", "]"}], ":=", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"VecToso3", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"V", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "}"}], 
           "\[Transpose]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"V", "[", 
            RowBox[{"[", 
             RowBox[{
              RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "}"}], 
          "\[Transpose]"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}]}], "}"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"se3ToVec", "[", "Vskew_", "]"}], ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{
      "Takes", " ", "an", " ", "element", " ", "of", " ", "se3", " ", 
       RowBox[{"(", "Vskew", ")"}], " ", "and", " ", "returns", " ", "the", 
       " ", "corresponding", " ", "6"}], "-", 
      RowBox[{"vector", " ", "spatial", " ", 
       RowBox[{
       "velocity", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "Sample"}]}]}], ":", "\[IndentingNewLine]", "\t", "Input", ":", " ", 
     RowBox[{
      RowBox[{"se3ToVec", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0"}], "}"}]}], "}"}], "]"}], 
      "\[IndentingNewLine]", "\t", "Output"}], ":", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", "1", "}"}], ",", 
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "0", "}"}], ",", 
       RowBox[{"{", "2", "}"}], ",", 
       RowBox[{"{", "3", "}"}], ",", 
       RowBox[{"{", "4", "}"}]}], "}"}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"se3ToVec", "[", "Vskew_", "]"}], ":=", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "2"}], "]"}], "]"}], ",", 
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"1", ",", "4"}], "]"}], "]"}], ",", 
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"2", ",", "4"}], "]"}], "]"}], ",", 
        RowBox[{"Vskew", "[", 
         RowBox[{"[", 
          RowBox[{"3", ",", "4"}], "]"}], "]"}]}], "}"}], "}"}], 
     "\[Transpose]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"Adjoint", "[", "T_", "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
       "Takes", " ", "a", " ", "transformation", " ", "matrix", " ", "T"}], 
       " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", "the", " ", 
        "6", " ", "x", " ", "6", " ", "adjoint", " ", 
        RowBox[{
         RowBox[{"representation", " ", "[", 
          SubscriptBox["Ad", "T"], "]"}], ".", "\[IndentingNewLine]", 
         "\[IndentingNewLine]", "Sample"}]}]}], ":", "\[IndentingNewLine]", 
      "\t", "Input", ":", " ", 
      RowBox[{"Adjoint", "[", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "2"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", "3"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "4"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
       "]"}]}], "//", 
     RowBox[{"MatrixForm", "\[IndentingNewLine]", "\t", 
      RowBox[{"Output", ":", " ", 
       TagBox[
        RowBox[{"(", "\[NoBreak]", GridBox[{
           {"0", "0", "1", "0", "0", "0"},
           {"0", "1", "0", "0", "0", "0"},
           {
            RowBox[{"-", "1"}], "0", "0", "0", "0", "0"},
           {
            RowBox[{"-", "3"}], 
            RowBox[{"-", "4"}], "0", "0", "0", "1"},
           {"2", "0", "4", "0", "1", "0"},
           {"0", "2", 
            RowBox[{"-", "3"}], 
            RowBox[{"-", "1"}], "0", "0"}
          },
          
          GridBoxAlignment->{
           "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
            "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
          GridBoxSpacings->{"Columns" -> {
              Offset[0.27999999999999997`], {
               Offset[0.7]}, 
              Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
              Offset[0.2], {
               Offset[0.4]}, 
              Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
        Function[BoxForm`e$, 
         MatrixForm[BoxForm`e$]]]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"Adjoint", "[", "T_", "]"}], ":=", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"T", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "3"}], ",", 
            RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], ",", "0"}], "}"}], ",", 
       
       RowBox[{"{", 
        RowBox[{
         RowBox[{
          RowBox[{"VecToso3", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"T", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}], "}"}], 
            "\[Transpose]"}], "]"}], ".", 
          RowBox[{"T", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "3"}], ",", 
             RowBox[{"1", ";;", "3"}]}], "]"}], "]"}]}], ",", 
         RowBox[{"T", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "3"}], ",", 
            RowBox[{"1", ";;", "3"}]}], "]"}], "]"}]}], "}"}]}], "}"}], 
     "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{"ScrewToAxis", "[", 
           RowBox[{"q_", ",", "s_", ",", "h_"}], "]"}], ":", 
          "\[IndentingNewLine]", 
          RowBox[{
           RowBox[{"Takes", " ", "a", " ", "point", " ", "q"}], " ", 
           "\[Element]", " ", 
           SuperscriptBox["R", "3"]}]}], ",", " ", 
         RowBox[{
          RowBox[{"a", " ", "unit", " ", "axis", " ", "s"}], " ", 
          "\[Element]", " ", 
          RowBox[{
           SuperscriptBox["R", "3"], " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{
              RowBox[{
              "\[LeftDoubleBracketingBar]", "s", 
               "\[RightDoubleBracketingBar]"}], " ", "=", " ", "1"}], ",", 
             " ", 
             RowBox[{
             "checked", " ", "by", " ", "function", " ", "and", " ", "will", 
              " ", "output", " ", "an", " ", "error", " ", "is", " ", "s", 
              " ", "is", " ", "not", " ", "a", " ", "unit", " ", "vector"}]}],
             ")"}]}]}], ",", " ", 
         RowBox[{
          RowBox[{
           RowBox[{"and", " ", "a", " ", "screw", " ", "pitch", " ", "h"}], 
           " ", "\[Element]", " ", 
           RowBox[{
           "R", " ", "and", " ", "returns", " ", "the", " ", "corresonding", 
            " ", "screw", " ", "axis", " ", "S"}]}], " ", "=", " ", 
          RowBox[{"(", 
           RowBox[{"\[Omega]", ",", "v"}], ")"}]}], ",", " ", 
         RowBox[{
         "which", " ", "is", " ", "a", " ", "normalized", " ", "\"\<unit\>\"",
           " ", "spatial", " ", 
          RowBox[{"velocity", ".", "  ", "This"}], " ", "function", " ", 
          "has", " ", "two", " ", 
          RowBox[{"case", ":", "\[IndentingNewLine]", "i"}]}]}], ")"}], " ", 
       "h", " ", "is", " ", "finite", "\[IndentingNewLine]", "\t", "ii"}], 
      ")"}], " ", "h", " ", "is", " ", "infinite", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"i", ".", "e", ".", " ", "pure"}], " ", "translation"}], ")"}],
      "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Sample", ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{"Case", " ", "i"}], ":", "\[IndentingNewLine]", "Input", ":", 
      " ", 
      RowBox[{
       RowBox[{"ScrewToAxis", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"2", ",", "3", ",", "4"}], "}"}], "}"}], "\[Transpose]"}],
          ",", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0"}], "}"}], "}"}], "\[Transpose]"}],
          ",", "6"}], "]"}], "\[IndentingNewLine]", "Output"}], ":", " ", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", "1", "}"}], ",", 
         RowBox[{"{", "0", "}"}], ",", 
         RowBox[{"{", "0", "}"}], ",", 
         RowBox[{"{", "6", "}"}], ",", 
         RowBox[{"{", "4", "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"-", "3"}], "}"}]}], "}"}], "\[IndentingNewLine]", 
       "\[IndentingNewLine]", "Case", " ", 
       RowBox[{"ii", ":", "\[IndentingNewLine]", "Input", ":", " ", 
        RowBox[{
         RowBox[{"ScrewToAxis", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"2", ",", "3", ",", "4"}], "}"}], "}"}], 
            "\[Transpose]"}], ",", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"{", 
              RowBox[{"1", ",", "0", ",", "0"}], "}"}], "}"}], 
            "\[Transpose]"}], ",", "Infinity"}], "]"}], "\[IndentingNewLine]", 
         RowBox[{"Output", ":", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", "0", "}"}], ",", 
            RowBox[{"{", "0", "}"}], ",", 
            RowBox[{"{", "0", "}"}], ",", 
            RowBox[{"{", "1", "}"}], ",", 
            RowBox[{"{", "0", "}"}], ",", 
            RowBox[{"{", "0", "}"}]}], "}"}]}]}]}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"ScrewToAxis", "[", 
     RowBox[{"q_", ",", "s_", ",", "h_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", "out", "}"}], ",", 
      RowBox[{
       RowBox[{"If", "[", 
        RowBox[{
         RowBox[{
          RowBox[{"Norm", "[", "s", "]"}], "\[NotEqual]", "1"}], ",", 
         RowBox[{
         "out", "=", 
          "\"\<\!\(\*OverscriptBox[\(s\), \(^\)]\) is not a unit \
vector\>\""}], ",", 
         RowBox[{"If", "[", 
          RowBox[{
           RowBox[{"h", "\[NotEqual]", "Infinity"}], ",", 
           RowBox[{"out", "=", 
            RowBox[{"ArrayFlatten", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", "s", "}"}], ",", 
               RowBox[{"{", 
                RowBox[{
                 RowBox[{
                  RowBox[{"{", 
                   RowBox[{"Cross", "[", 
                    RowBox[{
                    RowBox[{"Flatten", "[", 
                    RowBox[{"-", "s"}], "]"}], ",", 
                    RowBox[{"Flatten", "[", "q", "]"}]}], "]"}], "}"}], 
                  "\[Transpose]"}], "+", 
                 RowBox[{"h", "*", "s"}]}], "}"}]}], "}"}], "]"}]}], ",", 
           RowBox[{"out", "=", 
            RowBox[{"ArrayFlatten", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"{", 
                   RowBox[{"0", ",", "0", ",", "0"}], "}"}], "}"}], 
                 "\[Transpose]"}], "}"}], ",", 
               RowBox[{"{", "s", "}"}]}], "}"}], "]"}]}]}], "]"}]}], "]"}], 
       ";", "\[IndentingNewLine]", "out"}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{"AxisAng6", "[", "S\[Theta]_", "]"}], ":", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"Takes", " ", "a", " ", "6"}], "-", 
      RowBox[{
      "vector", " ", "of", " ", "exponential", " ", "coordinates", " ", 
       "S\[Theta]", " ", "and", " ", "returns", " ", "the", " ", "screw", " ",
        "axis", " ", "S", " ", "and", " ", "the", " ", "distanced", " ", 
       "traveled", " ", 
       RowBox[{"about", "/", "along"}], " ", "the", " ", "screw", " ", "axis",
        " ", 
       RowBox[{"\[Theta]", ".", "  ", "The"}], " ", "first", " ", "element", 
       " ", "of", " ", "the", " ", "output", " ", "is", " ", "the", " ", 
       "screw", " ", "axis", " ", "S", " ", "and", " ", "the", " ", "second", 
       " ", "is", " ", "the", " ", "distance", " ", 
       RowBox[{
       "\[Theta]", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        "Sample"}]}]}], ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Rotation", " ", "+", " ", 
      RowBox[{"Translation", ":", "\[IndentingNewLine]", "Input", ":", " ", 
       RowBox[{
        RowBox[{"AxisAng6", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "4", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "8", "}"}], ",", 
           RowBox[{"{", "16", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"-", "12"}], "}"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", "1", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "2", "}"}], ",", 
              RowBox[{"{", "4", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"-", "3"}], "}"}]}], "}"}], ",", "4"}], "}"}], 
          "\[IndentingNewLine]", "\[IndentingNewLine]", "Translation", " ", 
          "Only"}], ":", "\[IndentingNewLine]", "Input", ":", " ", 
         RowBox[{
          RowBox[{"AxisAng6", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "4", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}]}], "}"}], "]"}], "\[IndentingNewLine]", 
          "Output"}], ":", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "1", "}"}], ",", 
             RowBox[{"{", "0", "}"}], ",", 
             RowBox[{"{", "0", "}"}]}], "}"}], ",", "4"}], "}"}]}]}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"AxisAng6", "[", "S\[Theta]_", "]"}], ":=", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"{", 
         RowBox[{"S\[Theta]", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "}"}], 
        "\[Transpose]"}], "\[Equal]", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0"}], "}"}], "}"}], "\[Transpose]"}]}],
       ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S\[Theta]", "/", 
         RowBox[{"Norm", "[", 
          RowBox[{"S\[Theta]", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "]"}]}], ",", 
        RowBox[{"Norm", "[", 
         RowBox[{"S\[Theta]", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "]"}]}], 
       "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"S\[Theta]", "/", 
         RowBox[{"Norm", "[", 
          RowBox[{"S\[Theta]", "[", 
           RowBox[{"[", 
            RowBox[{
             RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "]"}]}], ",", 
        RowBox[{"Norm", "[", 
         RowBox[{"S\[Theta]", "[", 
          RowBox[{"[", 
           RowBox[{
            RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "]"}]}], 
       "}"}]}], "]"}]}], "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"MatrixExp6", "[", 
       RowBox[{"S_", ",", "\[Theta]_"}], "]"}], ":", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Takes", " ", "a", " ", "6"}], "-", 
       RowBox[{
       "vector", " ", "of", " ", "exponential", " ", "coordinates", " ", 
        "S\[Theta]"}]}]}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "where", " ", "S", " ", "is", " ", "the", " ", "screw", " ", "axis", 
        " ", "and", " ", "\[Theta]", " ", "the", " ", "distance", " ", 
        "traveled", " ", 
        RowBox[{"about", "/", "along"}], " ", "it", " ", "and", " ", 
        "returns", " ", 
        RowBox[{"T", "'"}]}], " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{"(", "3", ")"}], " ", "that", " ", "is", " ", "achieved", " ",
         "by", " ", "traveling", " ", 
        RowBox[{"along", "/", "about"}], " ", "the", " ", "screw", " ", 
        "axis", " ", "S", " ", "a", " ", "distance", " ", "\[Theta]", " ", 
        "from", " ", "an", " ", "initial", " ", "configuration", " ", "T"}]}],
       " ", "=", " ", 
      RowBox[{
       RowBox[{"I", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Sample", ":", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{
         "\[LeftDoubleBracketingBar]", "\[Omega]", 
          "\[RightDoubleBracketingBar]"}]}]}], " ", "=", " ", 
       RowBox[{
        RowBox[{
         RowBox[{"1", ":", "\[IndentingNewLine]", "Input", ":", " ", 
          RowBox[{"MatrixExp6", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", "1", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "2", "}"}], ",", 
              RowBox[{"{", "4", "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"-", "3"}], "}"}]}], "}"}], ",", "Pi"}], "]"}]}], "//", 
         RowBox[{"MatrixForm", "\[IndentingNewLine]", 
          RowBox[{"Output", ":", " ", 
           RowBox[{
            TagBox[
             RowBox[{"(", "\[NoBreak]", GridBox[{
                {"1", "0", "0", 
                 RowBox[{"2", " ", "\[Pi]"}]},
                {"0", 
                 RowBox[{"-", "1"}], "0", "6"},
                {"0", "0", 
                 RowBox[{"-", "1"}], "8"},
                {"0", "0", "0", "1"}
               },
               
               GridBoxAlignment->{
                "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
               GridBoxSpacings->{"Columns" -> {
                   Offset[0.27999999999999997`], {
                    Offset[0.7]}, 
                   Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                 "Rows" -> {
                   Offset[0.2], {
                    Offset[0.4]}, 
                   Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
             Function[BoxForm`e$, 
              MatrixForm[BoxForm`e$]]], "\[IndentingNewLine]", 
            "\[IndentingNewLine]", "\[Omega]"}]}]}]}], " ", "=", " ", 
        RowBox[{
         RowBox[{"0", ":", "\[IndentingNewLine]", "Input", ":", " ", 
          RowBox[{"MatrixExp6", "[", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "1", "}"}], ",", 
              RowBox[{"{", "0", "}"}], ",", 
              RowBox[{"{", "0", "}"}]}], "}"}], ",", "3"}], "]"}]}], "//", 
         RowBox[{"MatrixForm", "\[IndentingNewLine]", 
          RowBox[{"Output", ":", " ", 
           TagBox[
            RowBox[{"(", "\[NoBreak]", GridBox[{
               {"1", "0", "0", "3"},
               {"0", "1", "0", "0"},
               {"0", "0", "1", "0"},
               {"0", "0", "0", "1"}
              },
              
              GridBoxAlignment->{
               "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
                "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
              GridBoxSpacings->{"Columns" -> {
                  Offset[0.27999999999999997`], {
                   Offset[0.7]}, 
                  Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, 
                "Rows" -> {
                  Offset[0.2], {
                   Offset[0.4]}, 
                  Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
            Function[BoxForm`e$, 
             MatrixForm[BoxForm`e$]]]}]}]}]}]}]}]}], "\[IndentingNewLine]", 
    "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MatrixExp6", "[", 
     RowBox[{"S_", ",", "\[Theta]_"}], "]"}], ":=", 
    RowBox[{"ArrayFlatten", "[", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{
         RowBox[{"MatrixExp3", "[", 
          RowBox[{
           RowBox[{
            RowBox[{"{", 
             RowBox[{"S", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "}"}], 
            "\[Transpose]"}], ",", "\[Theta]"}], "]"}], ",", 
         RowBox[{
          RowBox[{"(", 
           RowBox[{
            RowBox[{
             RowBox[{"IdentityMatrix", "[", "3", "]"}], "*", "\[Theta]"}], 
            "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"1", "-", 
               RowBox[{"Cos", "[", "\[Theta]", "]"}]}], ")"}], "*", 
             RowBox[{"VecToso3", "[", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"S", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "}"}], 
               "\[Transpose]"}], "]"}]}], "+", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{"\[Theta]", "-", 
               RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}], "*", 
             RowBox[{"MatrixPower", "[", 
              RowBox[{
               RowBox[{"VecToso3", "[", 
                RowBox[{
                 RowBox[{"{", 
                  RowBox[{"S", "[", 
                   RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", "1"}], "]"}], "]"}], "}"}],
                  "\[Transpose]"}], "]"}], ",", "2"}], "]"}]}]}], ")"}], ".", 
          
          RowBox[{
           RowBox[{"{", 
            RowBox[{"S", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"4", ";;", "6"}], ",", "1"}], "]"}], "]"}], "}"}], 
           "\[Transpose]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}]}], "}"}], "]"}]}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{
               RowBox[{
                RowBox[{
                 RowBox[{"MatrixLog", "[", "T_", "]"}], ":", 
                 "\[IndentingNewLine]", 
                 RowBox[{
                  RowBox[{
                  "Takes", " ", "a", " ", "transformation", " ", "matrix", 
                   " ", "T"}], " ", "\[Element]", " ", 
                  RowBox[{
                   RowBox[{"SE", 
                    RowBox[{"(", "3", ")"}], " ", "and", " ", "returns", " ", 
                    "the", " ", "corresponding", " ", "6"}], "-", 
                   RowBox[{
                   "vector", " ", "V", " ", "of", " ", "expoinential", " ", 
                    "coordinates"}]}]}]}], ",", " ", 
                RowBox[{
                 RowBox[{"where", " ", "V"}], " ", "=", " ", 
                 RowBox[{
                  RowBox[{"S\[Theta]", ".", "  ", "This"}], " ", "function", 
                  " ", "considers", " ", "three", " ", 
                  RowBox[{"cases", ":", "\[IndentingNewLine]", "i"}]}]}]}], 
               ")"}], " ", "R"}], " ", "=", " ", "I"}], ",", " ", 
            RowBox[{
             RowBox[{"i", ".", "e", ".", " ", "\[Omega]"}], " ", "=", " ", 
             RowBox[{"0", "\[IndentingNewLine]", "\t", "ii"}]}]}], ")"}], " ", 
          RowBox[{"Tr", "[", "R", "]"}]}], " ", "=", " ", 
         RowBox[{"-", "1"}]}], ",", " ", 
        RowBox[{
        "in", " ", "which", " ", "case", " ", "it", " ", "is", " ", "solved", 
         " ", "like", " ", "in", " ", "MatrixExp3", " ", "where", " ", 
         "three", " ", "vectors", " ", "are", " ", "checked", " ", "to", " ", 
         "see", " ", "which", " ", "one", " ", "is", " ", "a", " ", 
         "feasible", " ", 
         RowBox[{"solution", ".", "\[IndentingNewLine]", "\t\t", "iii"}]}]}], 
       ")"}], " ", "It", " ", "does", " ", "not", " ", "fall", " ", "into", 
      " ", "one", " ", "of", " ", "the", " ", "above", " ", "special", " ", 
      "cases", " ", "and", " ", "can", " ", "be", " ", "solved", " ", 
      "through", " ", "\[Theta]", " ", "and", " ", 
      RowBox[{
       SuperscriptBox["G", 
        RowBox[{"-", "1"}]], ".", "\[IndentingNewLine]", 
       "\[IndentingNewLine]", 
       RowBox[{"Samples", ":"}]}]}], "\[IndentingNewLine]", ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Case", " ", 
      RowBox[{"i", ":", "\[IndentingNewLine]", "Input", ":", " ", 
       RowBox[{
        RowBox[{"MatrixLog6", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", "3"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "1", ",", "0"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
         "]"}], "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "3", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}]}], "}"}]}]}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Case", " ", 
      RowBox[{"ii", ":", "\[IndentingNewLine]", "Input", ":", " ", 
       RowBox[{
        RowBox[{"MatrixLog6", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", 
             RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", 
             RowBox[{"-", "1"}], ",", "0", ",", 
             RowBox[{"-", "8"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "1"}], ",", "6"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
         "]"}], "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", "\[Pi]", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", " ", "\[Pi]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"3", " ", "\[Pi]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"4", " ", "\[Pi]"}], "}"}]}], "}"}]}]}]}]}], ";", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"Case", " ", 
      RowBox[{"iii", ":", "\[IndentingNewLine]", "Input", ":", " ", 
       RowBox[{
        RowBox[{"MatrixLog6", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "0", ",", "0", ",", "\[Pi]"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", 
             RowBox[{"-", "1"}], ",", 
             RowBox[{"-", "1"}]}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "1", ",", "0", ",", "7"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], 
         "]"}], "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            FractionBox["\[Pi]", "2"], "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "0", "}"}], ",", 
           RowBox[{"{", "\[Pi]", "}"}], ",", 
           RowBox[{"{", 
            FractionBox[
             RowBox[{"3", " ", "\[Pi]"}], "2"], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"2", " ", "\[Pi]"}], "}"}]}], "}"}]}]}]}]}]}], 
    "\[IndentingNewLine]", "*)"}], "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{
     RowBox[{"MatrixLog6", "[", "T_", "]"}], ":=", 
     RowBox[{"Module", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"out", ",", "\[Theta]"}], "}"}], ",", 
       RowBox[{
        RowBox[{"\[Theta]", "=", 
         RowBox[{"ArcCos", "[", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{
             RowBox[{"Tr", "[", 
              RowBox[{"T", "[", 
               RowBox[{"[", 
                RowBox[{
                 RowBox[{"1", ";;", "3"}], ",", 
                 RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "]"}], "-", "1"}], 
            ")"}], "/", "2"}], "]"}]}], ";", 
        RowBox[{"Which", "[", 
         RowBox[{
          RowBox[{
           RowBox[{
            RowBox[{"T", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", 
               RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "\[Equal]", 
            RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "&&", 
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"T", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}], "]"}], 
            "\[NotEqual]", "0"}]}], ",", 
          RowBox[{"out", "=", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Flatten", "[", 
              RowBox[{"{", 
               RowBox[{"0", ",", "0", ",", "0", ",", 
                RowBox[{"T", "[", 
                 RowBox[{"[", 
                  RowBox[{
                   RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}]}], 
               "}"}], "]"}], "}"}], "\[Transpose]"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"T", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", 
               RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "\[Equal]", 
            RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "&&", 
           RowBox[{
            RowBox[{"Norm", "[", 
             RowBox[{"T", "[", 
              RowBox[{"[", 
               RowBox[{
                RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}], "]"}], 
            "\[Equal]", "0"}]}], ",", 
          RowBox[{"out", "=", "\"\<Error - No Movement\>\""}], ",", 
          RowBox[{
           RowBox[{"Tr", "[", 
            RowBox[{"T", "[", 
             RowBox[{"[", 
              RowBox[{
               RowBox[{"1", ";;", "3"}], ",", 
               RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "]"}], "\[Equal]", 
           RowBox[{"-", "1"}]}], ",", 
          RowBox[{"Which", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"T", "[", 
               RowBox[{"[", 
                RowBox[{"3", ",", "3"}], "]"}], "]"}]}], "\[NotEqual]", " ", 
             "0"}], ",", 
            RowBox[{"out", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                    "*", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}]}], "}"}], "}"}], 
                    "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "*", 
                    RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"Pi", "/", "2"}], "]"}]}]}], ")"}], "*", 
                    RowBox[{"MatrixPower", "[", 
                    RowBox[{
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "3"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "3"}], "]"}], "]"}]}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}], ",", "2"}], "]"}]}]}], ")"}], 
                   ".", 
                   RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}]}]}], 
                 "]"}], "}"}], "\[Transpose]"}], "*", "Pi"}]}], ",", 
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"T", "[", 
               RowBox[{"[", 
                RowBox[{"2", ",", "2"}], "]"}], "]"}]}], "\[NotEqual]", "0"}],
             ",", 
            RowBox[{"out", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                    "*", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "*", 
                    RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"Pi", "/", "2"}], "]"}]}]}], ")"}], "*", 
                    RowBox[{"MatrixPower", "[", 
                    RowBox[{
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "2"}], "]"}], "]"}], ",", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "2"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "2"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}], ",", "2"}], "]"}]}]}], ")"}], 
                   ".", 
                   RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}]}]}], 
                 "]"}], "}"}], "\[Transpose]"}], "*", "Pi"}]}], ",", 
            RowBox[{
             RowBox[{"1", "+", 
              RowBox[{"T", "[", 
               RowBox[{"[", 
                RowBox[{"1", ",", "1"}], "]"}], "]"}]}], "\[NotEqual]", " ", 
             "0"}], ",", 
            RowBox[{"out", "=", 
             RowBox[{
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Join", "[", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                    "*", 
                   RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "1"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "[", 
                    RowBox[{"[", "1", "]"}], "]"}]}], ",", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "*", 
                    RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "1"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}]}], "+", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "/", "Pi"}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"Pi", "/", "2"}], "]"}]}]}], ")"}], "*", 
                    RowBox[{"MatrixPower", "[", 
                    RowBox[{
                    RowBox[{"VecToso3", "[", 
                    RowBox[{
                    RowBox[{"1", "/", 
                    RowBox[{"Sqrt", "[", 
                    RowBox[{"2", 
                    RowBox[{"(", 
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ")"}]}], "]"}]}],
                     "*", 
                    RowBox[{
                    RowBox[{"{", 
                    RowBox[{"{", 
                    RowBox[{
                    RowBox[{"1", "+", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"1", ",", "1"}], "]"}], "]"}]}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"2", ",", "1"}], "]"}], "]"}], ",", 
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{"3", ",", "1"}], "]"}], "]"}]}], "}"}], "}"}], 
                    "\[Transpose]"}]}], "]"}], ",", "2"}], "]"}]}]}], ")"}], 
                   ".", 
                   RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}]}]}], 
                 "]"}], "}"}], "\[Transpose]"}], "*", "Pi"}]}]}], "]"}], ",", 
          "True", ",", 
          RowBox[{"out", "=", 
           RowBox[{
            RowBox[{
             RowBox[{"{", 
              RowBox[{"Join", "[", 
               RowBox[{
                RowBox[{
                 RowBox[{
                  RowBox[{"so3ToVec", "[", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], 
                    "\[Transpose]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}], "]"}], 
                  "\[Transpose]"}], "[", 
                 RowBox[{"[", "1", "]"}], "]"}], ",", 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"1", "/", "\[Theta]"}], "*", 
                    RowBox[{"IdentityMatrix", "[", "3", "]"}]}], "-", 
                   RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], 
                    "\[Transpose]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}], ")"}]}],
                    "+", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"1", "/", "\[Theta]"}], "-", 
                    RowBox[{
                    RowBox[{"1", "/", "2"}], "*", 
                    RowBox[{"Cot", "[", 
                    RowBox[{"\[Theta]", "/", "2"}], "]"}]}]}], ")"}], "*", 
                    RowBox[{"MatrixPower", "[", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], "-", 
                    RowBox[{
                    RowBox[{"T", "[", 
                    RowBox[{"[", 
                    RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", 
                    RowBox[{"1", ";;", "3"}]}], "]"}], "]"}], 
                    "\[Transpose]"}]}], ")"}], "/", 
                    RowBox[{"(", 
                    RowBox[{"2", "*", 
                    RowBox[{"Sin", "[", "\[Theta]", "]"}]}], ")"}]}], ",", 
                    "2"}], "]"}]}]}], ")"}], ".", 
                 RowBox[{"T", "[", 
                  RowBox[{"[", 
                   RowBox[{
                    RowBox[{"1", ";;", "3"}], ",", "4"}], "]"}], "]"}]}]}], 
               "]"}], "}"}], "\[Transpose]"}], "*", "\[Theta]"}]}]}], "]"}], 
        ";", 
        RowBox[{"Return", "[", "out", "]"}]}]}], "]"}]}], ";"}], 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"FKinFixed", "[", 
       RowBox[{"M_", ",", "Si_", ",", "\[Theta]i_"}], "]"}], ":", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Takes", " ", "M"}], " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{"(", "3", ")"}]}]}]}], ",", " ", 
     RowBox[{
      RowBox[{
      "which", " ", "represents", " ", "the", " ", "position", " ", "and", 
       " ", "orientation", " ", "of", " ", "the", " ", "end"}], "-", 
      RowBox[{
      "effector", " ", "frame", " ", "at", " ", "the", " ", "home", " ", 
       "position", " ", 
       RowBox[{"(", 
        RowBox[{"\[Theta]i", " ", "=", " ", 
         RowBox[{"0", " ", "for", " ", "all", " ", "joints"}]}], ")"}]}]}], 
     ",", " ", 
     RowBox[{
     "a", " ", "list", " ", "of", " ", "screw", " ", "axes", " ", "Si", " ", 
      "for", " ", "all", " ", "the", " ", "joints", " ", "of", " ", "robot", 
      " ", "that", " ", "are", " ", "expressed", " ", "in", " ", "the", " ", 
      "fixed", " ", "world", " ", "frame"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "and", " ", "a", " ", "list", " ", "of", " ", "joint", " ", 
        "coordinates", " ", 
        RowBox[{"\[Theta]i", ".", "  ", "The"}], " ", "function", " ", 
        "returns", " ", "a", " ", "transformation", " ", "matrix", " ", "T"}],
        " ", "\[Element]", " ", 
       RowBox[{
        RowBox[{"SE", 
         RowBox[{"(", "3", ")"}], " ", "which", " ", "represents", " ", "the",
          " ", "end"}], "-", 
        RowBox[{
        "effector", " ", "frame", " ", "when", " ", "all", " ", "the", " ", 
         "joint", " ", "angles", " ", "are", " ", 
         RowBox[{
         "specified", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
          "Sample", ":", "\[IndentingNewLine]", "Input", ":"}]}]}]}]}], 
      "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
      RowBox[{"L0", "=", "4"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L1", "=", "3"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L2", "=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L3", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"M", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", 
           RowBox[{"L0", "+", "L2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"L1", "-", "L3"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"S1", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "L0", ",", "0", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"S2", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"S3", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"-", 
            RowBox[{"(", 
             RowBox[{"L0", "+", "L2"}], ")"}]}], ",", "0", ",", 
           RowBox[{"-", ".1"}]}], "}"}], "}"}], "\[Transpose]"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"St", "=", 
       RowBox[{"{", 
        RowBox[{"S1", ",", "S2", ",", "S3"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Theta]1", "=", 
       RowBox[{"Pi", "/", "2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]2", "=", "3"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]3", "=", "Pi"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]t", "=", 
       RowBox[{"{", 
        RowBox[{"\[Theta]1", ",", "\[Theta]2", ",", "\[Theta]3"}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FKinFixed", "[", 
        RowBox[{"M", ",", "St", ",", "\[Theta]t"}], "]"}], "//", 
       RowBox[{"MatrixForm", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0.", "1.", "0.", 
              RowBox[{"-", "5."}]},
             {"1.", "0.", "0.", "4."},
             {"0.", "0.", 
              RowBox[{"-", "1."}], "1.6858407346410207"},
             {"0.", "0.", "0.", "1."}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]]}]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FKinFixed", "[", 
     RowBox[{"M_", ",", "Si_", ",", "\[Theta]i_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "j", ",", "T"}], "}"}], ",", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"Length", "[", "Si", "]"}]}], ";", 
       RowBox[{"T", "=", "M"}], ";", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"T", "=", 
          RowBox[{
           RowBox[{"MatrixExp6", "[", 
            RowBox[{
             RowBox[{"Si", "[", 
              RowBox[{"[", 
               RowBox[{"i", "-", "j", "+", "1"}], "]"}], "]"}], ",", 
             RowBox[{"\[Theta]i", "[", 
              RowBox[{"[", 
               RowBox[{"i", "-", "j", "+", "1"}], "]"}], "]"}]}], "]"}], ".", 
           "T"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "i"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "T", "]"}]}]}], "]"}]}], "\[IndentingNewLine]", 
   "\[IndentingNewLine]", 
   RowBox[{"(*", 
    RowBox[{
     RowBox[{
      RowBox[{"FKinBody", "[", 
       RowBox[{"M_", ",", "Bi_", ",", "\[Theta]i_"}], "]"}], ":", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Takes", " ", "M"}], " ", "\[Element]", " ", 
       RowBox[{"SE", 
        RowBox[{"(", "3", ")"}]}]}]}], ",", " ", 
     RowBox[{
      RowBox[{
      "which", " ", "represents", " ", "the", " ", "position", " ", "and", 
       " ", "orientation", " ", "of", " ", "the", " ", "end"}], "-", 
      RowBox[{
      "effector", " ", "frame", " ", "at", " ", "the", " ", "home", " ", 
       "position", " ", 
       RowBox[{"(", 
        RowBox[{"\[Theta]i", " ", "=", " ", 
         RowBox[{"0", " ", "for", " ", "all", " ", "joints"}]}], ")"}]}]}], 
     ",", " ", 
     RowBox[{
     "a", " ", "list", " ", "of", " ", "screw", " ", "axes", " ", "Bi", " ", 
      "for", " ", "all", " ", "the", " ", "joints", " ", "of", " ", "robot", 
      " ", "that", " ", "are", " ", "expressed", " ", "in", " ", "the", " ", 
      "body", " ", "frame"}], ",", " ", 
     RowBox[{
      RowBox[{
       RowBox[{
       "and", " ", "a", " ", "list", " ", "of", " ", "joint", " ", 
        "coordinates", " ", 
        RowBox[{"\[Theta]i", ".", "  ", "The"}], " ", "function", " ", 
        "returns", " ", "a", " ", "transformation", " ", "matrix", " ", "T"}],
        " ", "\[Element]", " ", 
       RowBox[{
        RowBox[{"SE", 
         RowBox[{"(", "3", ")"}], " ", "which", " ", "represents", " ", "the",
          " ", "end"}], "-", 
        RowBox[{
        "effector", " ", "frame", " ", "when", " ", "all", " ", "the", " ", 
         "joint", " ", "angles", " ", "are", " ", 
         RowBox[{
         "specified", ".", "\[IndentingNewLine]", "\[IndentingNewLine]", 
          RowBox[{
          "Sample", ":", "\[IndentingNewLine]", "Input", ":"}]}]}]}]}], 
      "\[IndentingNewLine]", ";", "\[IndentingNewLine]", 
      RowBox[{"L0", "=", "4"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L1", "=", "3"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L2", "=", "2"}], ";", "\[IndentingNewLine]", 
      RowBox[{"L3", "=", "1"}], ";", "\[IndentingNewLine]", 
      RowBox[{"M", "=", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "1"}], ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "1", ",", "0", ",", 
           RowBox[{"L0", "+", "L2"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", 
           RowBox[{"L1", "-", "L3"}]}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"B1", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", 
           RowBox[{"-", "1"}], ",", "L2", ",", "0", ",", "0"}], "}"}], "}"}], 
        "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"B2", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "0", ",", "0", ",", "1", ",", "0"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"B3", "=", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"{", 
          RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", ".1"}], 
          "}"}], "}"}], "\[Transpose]"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"Bt", "=", 
       RowBox[{"{", 
        RowBox[{"B1", ",", "B2", ",", "B3"}], "}"}]}], ";", 
      "\[IndentingNewLine]", 
      RowBox[{"\[Theta]1", "=", 
       RowBox[{"Pi", "/", "2"}]}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]2", "=", "3"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]3", "=", "Pi"}], ";", "\[IndentingNewLine]", 
      RowBox[{"\[Theta]t", "=", 
       RowBox[{"{", 
        RowBox[{"\[Theta]1", ",", "\[Theta]2", ",", "\[Theta]3"}], "}"}]}], 
      ";", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"FKinBody", "[", 
        RowBox[{"M", ",", "Bt", ",", "\[Theta]t"}], "]"}], "//", 
       RowBox[{"MatrixForm", "\[IndentingNewLine]", "\[IndentingNewLine]", 
        RowBox[{"Output", ":", " ", 
         TagBox[
          RowBox[{"(", "\[NoBreak]", GridBox[{
             {"0.", "1.", "0.", 
              RowBox[{"-", "5."}]},
             {"1.", "0.", "0.", "4."},
             {"0.", "0.", 
              RowBox[{"-", "1."}], "1.6858407346410207"},
             {"0.", "0.", "0.", "1."}
            },
            
            GridBoxAlignment->{
             "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, 
              "Rows" -> {{Baseline}}, "RowsIndexed" -> {}},
            GridBoxSpacings->{"Columns" -> {
                Offset[0.27999999999999997`], {
                 Offset[0.7]}, 
                Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
                Offset[0.2], {
                 Offset[0.4]}, 
                Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
          Function[BoxForm`e$, 
           MatrixForm[BoxForm`e$]]]}]}]}]}]}], "\[IndentingNewLine]", "*)"}], 
   "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"FKinBody", "[", 
     RowBox[{"M_", ",", "Bi_", ",", "\[Theta]i_"}], "]"}], ":=", 
    RowBox[{"Module", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"i", ",", "j", ",", "T"}], "}"}], ",", 
      RowBox[{
       RowBox[{"i", "=", 
        RowBox[{"Length", "[", "Bi", "]"}]}], ";", 
       RowBox[{"T", "=", "M"}], ";", 
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"T", "=", 
          RowBox[{"T", ".", 
           RowBox[{"MatrixExp6", "[", 
            RowBox[{
             RowBox[{"Bi", "[", 
              RowBox[{"[", "j", "]"}], "]"}], ",", 
             RowBox[{"\[Theta]i", "[", 
              RowBox[{"[", "j", "]"}], "]"}]}], "]"}]}]}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", "i"}], "}"}]}], "]"}], ";", "\[IndentingNewLine]", 
       RowBox[{"Return", "[", "T", "]"}]}]}], "]"}]}]}]}]], "Input",
 CellChangeTimes->{{3.654107438701495*^9, 3.6541075770931664`*^9}, {
   3.6541076103152647`*^9, 3.654107726674172*^9}, {3.654107800327899*^9, 
   3.654107805926005*^9}, {3.654107842157054*^9, 3.654107956534466*^9}, {
   3.6541080276373253`*^9, 3.654108039845397*^9}, {3.654108208328875*^9, 
   3.654108267778264*^9}, {3.654108316603101*^9, 3.65410832858707*^9}, {
   3.654122072990996*^9, 3.654122200142358*^9}, {3.654122232524707*^9, 
   3.6541222637488813`*^9}, {3.654122372486209*^9, 3.65412253592478*^9}, {
   3.654122571686759*^9, 3.654122685636675*^9}, {3.654122740902017*^9, 
   3.6541228215630703`*^9}, {3.654122865671712*^9, 3.654122935620612*^9}, {
   3.654123032181581*^9, 3.6541230914473333`*^9}, {3.654123152783122*^9, 
   3.6541232043612537`*^9}, {3.654123304611115*^9, 3.654123341073502*^9}, {
   3.654123502235703*^9, 3.654123578362132*^9}, {3.654123664279245*^9, 
   3.654123683195951*^9}, {3.6541237878998413`*^9, 3.6541238249788847`*^9}, {
   3.654123940392714*^9, 3.654123947510108*^9}, {3.654124026309593*^9, 
   3.654124026885428*^9}, 3.6541241152729683`*^9, 3.654124170343902*^9, {
   3.6541246995439568`*^9, 3.654124712871656*^9}, {3.6541251843297157`*^9, 
   3.654125231518578*^9}, {3.6541254856851683`*^9, 3.65412548908077*^9}, {
   3.654125547742125*^9, 3.654125551165526*^9}, {3.654125930807577*^9, 
   3.654126007244483*^9}, {3.654126127665163*^9, 3.654126191634789*^9}, {
   3.654126236482831*^9, 3.654126250153975*^9}, {3.6541262848658533`*^9, 
   3.654126288991514*^9}, {3.654126323055903*^9, 3.654126399729628*^9}, {
   3.654126435349374*^9, 3.654126447266036*^9}, {3.654126530077552*^9, 
   3.6541265937421*^9}, {3.654126679867402*^9, 3.6541267650289497`*^9}, {
   3.6541267969631968`*^9, 3.654126798410089*^9}, {3.654126829860013*^9, 
   3.654126881359337*^9}, {3.6541269393824577`*^9, 3.654126959132009*^9}, {
   3.654127079773924*^9, 3.654127194954756*^9}, {3.654127229244482*^9, 
   3.654127253953713*^9}, {3.6541278694900227`*^9, 3.654127878663176*^9}, {
   3.654127969775614*^9, 3.6541279938293123`*^9}, {3.654128051763153*^9, 
   3.654128134016169*^9}, {3.654128326830834*^9, 3.654128326972948*^9}, {
   3.654182305132535*^9, 3.654182317491791*^9}, {3.65418238746202*^9, 
   3.654182511491269*^9}, {3.654182551115921*^9, 3.654182559209998*^9}, {
   3.6541826265390177`*^9, 3.654182732425318*^9}, {3.654182795218339*^9, 
   3.654182802306821*^9}, {3.654182858360195*^9, 3.654182976637673*^9}, {
   3.65418309291822*^9, 3.6541831115452337`*^9}, {3.654183280620055*^9, 
   3.654183381285778*^9}, {3.6541834216733217`*^9, 3.65418343026462*^9}, {
   3.65418347398075*^9, 3.654183479016459*^9}, {3.654183517743698*^9, 
   3.654183590244978*^9}, {3.654183629340012*^9, 3.654183659551435*^9}, {
   3.654183828746057*^9, 3.654183869187777*^9}, {3.654183918271063*^9, 
   3.6541839184304667`*^9}, {3.654206461375032*^9, 3.6542064948942213`*^9}, {
   3.6542065261576433`*^9, 3.654206710642645*^9}, {3.65420685898112*^9, 
   3.654206859498214*^9}, {3.654206912388175*^9, 3.6542069199221067`*^9}, {
   3.654206956850091*^9, 3.654206957769821*^9}, {3.6542070885864773`*^9, 
   3.6542070905801163`*^9}, {3.6542071861274023`*^9, 3.654207197287834*^9}, {
   3.654207355631957*^9, 3.65420737546005*^9}, {3.654207422116619*^9, 
   3.6542074295958633`*^9}, {3.654207513008601*^9, 3.654207622631179*^9}, {
   3.6542077902321663`*^9, 3.6542079082040863`*^9}, {3.654208112675095*^9, 
   3.6542082406765347`*^9}, {3.654208390436673*^9, 3.654208437282127*^9}, {
   3.654208729398788*^9, 3.6542088242969923`*^9}, {3.654208875181876*^9, 
   3.6542089105814543`*^9}, {3.654209036563011*^9, 3.654209042056604*^9}, {
   3.654209131808134*^9, 3.654209211748107*^9}, {3.654277910558556*^9, 
   3.654277962902483*^9}, {3.6542785554956903`*^9, 3.654278555764879*^9}, {
   3.6542801407928543`*^9, 3.654280145647377*^9}, {3.654280336511973*^9, 
   3.654280388661951*^9}, {3.654735519742467*^9, 3.654735526212496*^9}, {
   3.654736711632904*^9, 3.654736744359725*^9}, {3.654736840726715*^9, 
   3.6547369027091503`*^9}, {3.6547369619155817`*^9, 3.65473711893006*^9}, 
   3.654737215212165*^9, {3.6547372623430433`*^9, 3.654737301717353*^9}, {
   3.654737434898181*^9, 3.654737445769989*^9}, {3.654737593349925*^9, 
   3.654737893647337*^9}, {3.654737938282483*^9, 3.654737939560112*^9}, {
   3.654737995469615*^9, 3.65473804382544*^9}, {3.65473814244207*^9, 
   3.65473826286047*^9}, {3.654738473301898*^9, 3.654738519313912*^9}, {
   3.654738551955141*^9, 3.654738559351729*^9}, {3.654738599129403*^9, 
   3.654738599566987*^9}, {3.654738653005966*^9, 3.654738704434928*^9}, {
   3.654738885183668*^9, 3.654738922018218*^9}, {3.654739011880048*^9, 
   3.65473910917871*^9}, {3.654739159170903*^9, 3.654739162120161*^9}, {
   3.6547393230277576`*^9, 3.6547393764227123`*^9}, {3.654739415181912*^9, 
   3.65473942023728*^9}, {3.654739453135948*^9, 3.654739679965816*^9}, {
   3.654739718627033*^9, 3.6547397334487553`*^9}, {3.654739765385715*^9, 
   3.654739851694334*^9}, {3.654739889466123*^9, 3.654740005071364*^9}, {
   3.6547400491757*^9, 3.654740154008595*^9}, 3.654740216700787*^9, {
   3.654740314399178*^9, 3.6547403286014967`*^9}, 3.6547403850818996`*^9, {
   3.654740521314966*^9, 3.654740541208376*^9}, {3.65474063388687*^9, 
   3.654740654515286*^9}, {3.654740701345427*^9, 3.654740810460566*^9}, {
   3.654740848239312*^9, 3.654741082783293*^9}, {3.654741274225429*^9, 
   3.65474127713437*^9}, 3.654741426789631*^9, {3.6547414571147537`*^9, 
   3.654741569824174*^9}, {3.654741604551594*^9, 3.65474161887015*^9}, {
   3.6547416933496304`*^9, 3.654741709459137*^9}, {3.654741935230948*^9, 
   3.654741945307493*^9}, {3.6547830386167917`*^9, 3.654783105454197*^9}, {
   3.6547832406606083`*^9, 3.6547832525310373`*^9}, {3.654783794511154*^9, 
   3.654783837663447*^9}, {3.65478390359721*^9, 3.654783909803577*^9}, {
   3.654783989474423*^9, 3.654784403124803*^9}, {3.654784520313846*^9, 
   3.654784622329711*^9}, {3.6547847231449842`*^9, 3.654784727983326*^9}, {
   3.654785122876478*^9, 3.654785187751635*^9}, {3.654785255283667*^9, 
   3.654785472044736*^9}, {3.654785554330287*^9, 3.6547855634367*^9}, {
   3.6547858133842907`*^9, 3.654785842420493*^9}, {3.654785988696732*^9, 
   3.654785999313698*^9}, {3.654786083383224*^9, 3.654786083827299*^9}, {
   3.654799998454865*^9, 3.654800009014682*^9}, 3.654800058896707*^9, {
   3.6548001027328*^9, 3.654800173381201*^9}, {3.654800206111162*^9, 
   3.654800346038969*^9}, {3.654800415767541*^9, 3.654800685527397*^9}, {
   3.654800717895743*^9, 3.6548007259529123`*^9}, {3.6548007560240192`*^9, 
   3.654800892868227*^9}, {3.654800961067473*^9, 3.6548010443125353`*^9}, {
   3.654801144205307*^9, 3.6548013970409203`*^9}, {3.654801447723054*^9, 
   3.6548014700938597`*^9}, {3.654801562889327*^9, 3.6548017505389137`*^9}, {
   3.6548017965315866`*^9, 3.654801838591158*^9}, {3.654801925163512*^9, 
   3.654801957336872*^9}, {3.654802037838778*^9, 3.654802097667626*^9}, {
   3.6548021338675137`*^9, 3.654802151746142*^9}, {3.6548021938035927`*^9, 
   3.65480226557542*^9}, {3.6548023434469347`*^9, 3.6548024564595747`*^9}, {
   3.654802493167995*^9, 3.654802498462143*^9}, {3.654802632969117*^9, 
   3.654802636326886*^9}, {3.6548026864101667`*^9, 3.6548027624957323`*^9}, {
   3.654802812209731*^9, 3.6548030159498*^9}, {3.6548066359524317`*^9, 
   3.654806720935005*^9}, {3.654806751992766*^9, 3.6548067587144833`*^9}, {
   3.654806821497799*^9, 3.654806889382121*^9}, {3.654807006283039*^9, 
   3.654807210369132*^9}, {3.654807340425975*^9, 3.6548074184588003`*^9}, {
   3.6548074913193197`*^9, 3.654807699931301*^9}, 3.6548078200861998`*^9, {
   3.654807890939335*^9, 3.65480791502777*^9}, {3.654807960842239*^9, 
   3.6548080712336483`*^9}, {3.654808128338978*^9, 3.6548081799548407`*^9}, {
   3.6548101758929577`*^9, 3.654810330104765*^9}, {3.654810401423953*^9, 
   3.654810408457419*^9}, {3.6548104718702717`*^9, 3.6548106690676603`*^9}, {
   3.6548107121438303`*^9, 3.6548108463298893`*^9}, {3.654810878513033*^9, 
   3.6548109250220337`*^9}, {3.654810973064028*^9, 3.6548109963255377`*^9}, {
   3.654811065383171*^9, 3.65481111435124*^9}, {3.6548111568410273`*^9, 
   3.654811165569319*^9}, {3.654811202562601*^9, 3.654811649746052*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
Code for the demos found in the pdf can be found by expanding the tab to right\
\>", "Subsubsection",
 CellChangeTimes->{{3.656120753974965*^9, 3.656120777397588*^9}}],

Cell["4)", "Text",
 CellChangeTimes->{{3.656120796109912*^9, 3.656120796501028*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Tsd", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", 
       RowBox[{"-", ".6"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", "1"}], ",", ".1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", "0", ",", "0", ",", ".1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L1", " ", "=", " ", 
   RowBox[{"425", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L2", " ", "=", " ", 
   RowBox[{"392", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"W1", " ", "=", " ", 
   RowBox[{"109", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"W2", " ", "=", " ", 
   RowBox[{"82", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"H1", " ", "=", " ", 
   RowBox[{"89", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"H2", " ", "=", " ", 
   RowBox[{"95", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "L1"}], "-", "L2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", 
       RowBox[{"-", "1"}], ",", 
       RowBox[{
        RowBox[{"-", "W1"}], "-", "W2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", 
       RowBox[{"H1", "-", "H2"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B1", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", 
       RowBox[{"W1", "+", "W2"}], ",", "0", ",", 
       RowBox[{"L1", "+", "L2"}]}], "}"}], "}"}], "\[Transpose]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B2", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "H2", ",", 
       RowBox[{
        RowBox[{"-", "L1"}], "-", "L2"}], ",", "0"}], "}"}], "}"}], 
    "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B3", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "H2", ",", 
       RowBox[{"-", "L2"}], ",", "0"}], "}"}], "}"}], "\[Transpose]"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B4", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "H2", ",", "0", ",", "0"}], "}"}],
      "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B5", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{"-", "1"}], ",", "0", ",", 
       RowBox[{"-", "W2"}], ",", "0", ",", "0"}], "}"}], "}"}], 
    "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"B6", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"B", "=", 
    RowBox[{"{", 
     RowBox[{"B1", ",", "B2", ",", "B3", ",", "B4", ",", "B5", ",", "B6"}], 
     "}"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IKinBody", "[", 
   RowBox[{"B", ",", "M", ",", "Tsd", ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", "0", ",", 
      RowBox[{"-", ".01"}], ",", "0", ",", ".01", ",", "0"}], "}"}], ",", 
    ".01", ",", ".001"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FKinBody", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", 
        RowBox[{
         RowBox[{"-", "L1"}], "-", "L2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", 
        RowBox[{"-", "1"}], ",", 
        RowBox[{
         RowBox[{"-", "W1"}], "-", "W2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", 
        RowBox[{"H1", "-", "H2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", "B", 
    ",", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "0.46949945826843015`"}], ",", "55.714685537265055`", ",", 
      
      RowBox[{"-", "117.98469417226988`"}], ",", "62.27074872739645`", ",", 
      RowBox[{"-", "0.4693679098674825`"}], ",", 
      RowBox[{"-", "1.571587945198965`"}]}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]}], "Input",
 CellChangeTimes->{{3.656104270071986*^9, 3.656104270257173*^9}, 
   3.6561052232674637`*^9, {3.65612081377553*^9, 3.6561208156308126`*^9}}],

Cell["5)", "Text",
 CellChangeTimes->{{3.656120801229445*^9, 3.656120801621058*^9}}],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Tsd", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", ".4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", ".4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L1", " ", "=", " ", 
   RowBox[{"550", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L2", " ", "=", " ", 
   RowBox[{"300", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"L3", " ", "=", " ", 
   RowBox[{"60", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"W1", " ", "=", " ", 
   RowBox[{"45", "/", "1000"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"M", " ", "=", " ", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", 
       RowBox[{"L1", "+", "L2", "+", "L3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}]}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S1", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S2", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S3", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S4", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", 
       RowBox[{"-", "L1"}], ",", "0", ",", "W1"}], "}"}], "}"}], 
    "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S5", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S6", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "1", ",", "0", ",", 
       RowBox[{
        RowBox[{"-", "L1"}], "-", "L2"}], ",", "0", ",", "0"}], "}"}], "}"}], 
    "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"S7", "=", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", "0", ",", "1", ",", "0", ",", "0", ",", "0"}], "}"}], 
     "}"}], "\[Transpose]"}]}], ";"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{
   RowBox[{"S", "=", 
    RowBox[{"{", 
     RowBox[{
     "S1", ",", "S2", ",", "S3", ",", "S4", ",", "S5", ",", "S6", ",", "S7"}],
      "}"}]}], ";"}], "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"IKinFixed", "[", 
   RowBox[{"S", ",", "M", ",", "Tsd", ",", 
    RowBox[{"{", 
     RowBox[{
     "0", ",", "0", ",", "0", ",", ".01", ",", "0", ",", ".01", ",", ".01"}], 
     "}"}], ",", ".01", ",", ".001"}], "]"}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"FKinFixed", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"1", ",", "0", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "1", ",", "0", ",", "0"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "1", ",", 
        RowBox[{"L1", "+", "L2", "+", "L3"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"0", ",", "0", ",", "0", ",", "1"}], "}"}]}], "}"}], ",", "S", 
    ",", 
    RowBox[{"{", 
     RowBox[{"2.5002238615346886`", ",", 
      RowBox[{"-", "0.29118355879486074`"}], ",", 
      RowBox[{"-", "2.289687416725524`"}], ",", "2.170866432490594`", ",", 
      "2.8356907857498936`", ",", "2.3419957310863833`", ",", 
      "21.585379501151866`"}], "}"}]}], "]"}], "//", "MatrixForm"}]}], "Input",\

 CellChangeTimes->{{3.656120827102017*^9, 3.6561208278782873`*^9}}]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{808, 602},
WindowMargins->{{17, Automatic}, {Automatic, 7}},
FrontEndVersion->"10.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (September 9, \
2014)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 153, 2, 92, "Title"],
Cell[CellGroupData[{
Cell[758, 28, 97, 1, 65, "Chapter"],
Cell[CellGroupData[{
Cell[880, 33, 87, 1, 64, "Section"],
Cell[970, 36, 42323, 972, 3139, "Input"],
Cell[CellGroupData[{
Cell[43318, 1012, 308, 6, 59, "Subsubsection"],
Cell[43629, 1020, 105185, 2563, 6800, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[148851, 3588, 177, 3, 29, "Subsubsection"],
Cell[149031, 3593, 84, 1, 30, "Text"],
Cell[149118, 3596, 4894, 146, 386, "Input"],
Cell[154015, 3744, 84, 1, 30, "Text"],
Cell[154102, 3747, 4417, 129, 369, "Input"]
}, Closed]]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

(* End of internal cache information *)
